/**************************************************************************

	nPOP-Q

	AdrList.c

	(C) Copyright 1999-2002 By Qta Sakamoto. All right reserved.

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include "General.h"
#include "Options.h"	//(nPOP-Q)

#ifdef UNICODE
	#define ustrchr wcschr
#else
	#define ustrchr strchr
#endif

extern int LvStyleEx;

/**************************************************************************
	Global Variables
**************************************************************************/

//OQ
extern HINSTANCE hInst;
extern HWND MainWnd;
extern struct TPMAILBOX *AddressBox;
extern HFONT hSmallFont;

#define ID_MENU_ADDR			(WM_APP + 401)		//AhXj[(nPOP-Q)

//HTREEITEM TreeView_InsertItemEx(HWND hTreeView, TCHAR *buf, int len, int Img, long lp, HTREEITEM hItem);

/******************************************************************************

	CreateAdrList

	ȈՃAhX̍쐬Ə

******************************************************************************/

HWND CreateAdrList(HWND hWnd)
{
	RECT rcClient;
	HWND hAdrList;
    HBITMAP hBitmap;
	HIMAGELIST ImageList;
	DWORD dwLvStyleEx;

	GetClientRect(hWnd, &rcClient);

#ifdef _WIN32_WCE
#define WS_EX_STYLE		0
#else
#define WS_EX_STYLE		WS_EX_NOPARENTNOTIFY | WS_EX_CLIENTEDGE
#endif
	hAdrList = CreateWindowEx(WS_EX_STYLE, WC_LISTVIEW, TEXT(""),
#ifdef _WIN32_WCE_LAGENDA
		WS_BORDER | WS_VISIBLE | WS_CHILD | WS_TABSTOP | LVS_REPORT | LVS_NOCOLUMNHEADER,
#else
		WS_BORDER | WS_VISIBLE | WS_CHILD | WS_TABSTOP | LVS_REPORT | LVS_NOCOLUMNHEADER,
#endif
		0, 0, 0, 0,
		hWnd, (HMENU)IDC_ADRLIST, hInst, NULL);
	if(hAdrList == NULL){
		return NULL;
	}

	dwLvStyleEx = LVS_EX_FULLROWSELECT | LVS_EX_INFOTIP;
#ifndef _WIN32_WCE
	dwLvStyleEx |= (LvStyleEx & (LVS_EX_FLATSB | LVS_EX_GRIDLINES));
#endif
	ListView_SetExtendedListViewStyle(hAdrList, dwLvStyleEx);

	//C[WXg̐ݒ
	ImageList = ImageList_Create (16, 16, ILC_COLOR, 5, 5);

    //rbg}bvC[W[h
	hBitmap = LoadBitmap (hInst, MAKEINTRESOURCE (IDB_TREEIMG));
	ImageList_Add (ImageList, hBitmap, NULL);
	DeleteObject (hBitmap);

	// C[W Xgo^
	//TreeView_SetImageList (hAdrList, ImageList, TVSIL_NORMAL);
	ListView_SetImageList(hAdrList, ImageList, LVSIL_SMALL);

	//wb_̐ݒ
	ListView_AddColumn(hAdrList, LVCFMT_LEFT, 80, STR_ADDR_NAME, 0);
	//ListView_AddColumn(hAdrList, LVCFMT_LEFT, 80, STR_ADDR_CMNT, 1);

	AdrList_SetAddressList(hWnd);

	return hAdrList;
}


/******************************************************************************
dst֖OorAhX (OD)
retփAhX
******************************************************************************/
TCHAR* AdrList_GetName (TCHAR* src, TCHAR* dst)
{
	TCHAR* p;
	TCHAR* m = 0;
	TCHAR* s = dst;
	TCHAR* t;

	lstrcpy (dst, src);

	p = ustrchr (s, TEXT('('));
	if (p != 0) {
		*p = 0;
		s = p+1;
		t = ustrchr (s, TEXT(')'));
		if (t != 0) *t = 0;
	}
	if (p > m) m = p+1;

	p = ustrchr (s, TEXT('<'));
	if (p != 0) {
		*p = 0;
		s = p+1;
		t = ustrchr (s, TEXT('>'));
		if (t != 0) *t = 0;
	}
	if (p > m) m = p+1;

	return m;
}

/******************************************************************************
tH[}bg
******************************************************************************/
void AdrList_FormName (TCHAR* out, int i)
{
	int no;
	int len = 0;
	TCHAR buf[MAX_PATH];
	TCHAR* cmnt = (*(AddressBox->tpMailItem + i))->Subject;
	TCHAR* name;
	TCHAR* addr = AdrList_GetName ((*(AddressBox->tpMailItem + i))->To, buf);
	if (addr == 0) {
		name = TEXT("");
		addr = buf;
	}
	else {
		name = buf;
	}
	if (cmnt == 0) {
		cmnt = TEXT("");
	}

	for (no = 0; g_Winpos.AdrForm[no] != 0; no++) {
		switch (g_Winpos.AdrForm[no]) {
		case TEXT('C'):
			lstrcpy (&out[len], cmnt);
			len += lstrlen(cmnt);
			break;
		case TEXT('A'):
			lstrcpy (&out[len], addr);
			len += lstrlen(addr);
			break;
		case TEXT('N'):
			lstrcpy (&out[len], name);
			len += lstrlen(name);
			break;
		default:
			out[len] = g_Winpos.AdrForm[no];
			len++;
			break;
		}
	}
	out[len] = 0;
}

/******************************************************************************

	AdrList_SetAddressList

	XgɃAhX̃Xg\

******************************************************************************/

void AdrList_SetAddressList(HWND hWnd)
{
	int i;
	TCHAR buf[256];
	HWND hAdrList;
	struct TPMAILITEM *tpMailItem;

	hAdrList = GetDlgItem (hWnd, IDC_ADRLIST);
	if (!hAdrList) return;

	ListView_DeleteAllItems (hAdrList);
//	TreeView_DeleteAllItems (hAdrList);
//	SendDlgItemMessage (hWnd, IDC_ADRLIST, LB_RESETCONTENT, 0, 0);

	for(i = 0;i < AddressBox->MailItemCnt;i++){
		if((AddressBox->tpMailItem + i) == NULL){
			continue;
		}
		tpMailItem = (*(AddressBox->tpMailItem + i));
		if (tpMailItem == NULL){
			continue;
		}

		buf[0] = 0;
		if (g_Winpos.AdrForm[0] == 0) {
			if (tpMailItem->Subject != NULL) {
				lstrcpy (buf, tpMailItem->Subject);
			}
			if (buf[0] == 0) {
				if (tpMailItem->To != NULL) {
					AdrList_GetName (tpMailItem->To, buf);
				}
			}
		}
		else {
			AdrList_FormName (buf, i);
		}
		//SendDlgItemMessage (hWnd, IDC_ADRLIST, LB_ADDSTRING, 0, (LPARAM)buf);
		ListView_InsertItemEx(hAdrList, buf, 256, 4, i, i);
		//TreeView_InsertItemEx(hAdrList, buf, 256, 4, i, NULL);
	}
}

/******************************************************************************

	AdrList_GetAddress

	ĨAhX擾

******************************************************************************/

TCHAR* AdrList_GetAddress (int idx)
{
	int i;
	int k = 0;
	for(i = 0;i < AddressBox->MailItemCnt;i++){
		if((AddressBox->tpMailItem + i) == NULL){
			continue;
		}
		if ((*(AddressBox->tpMailItem + i))->To != NULL) {
			if (k == idx) {
				return (*(AddressBox->tpMailItem + i))->To;
			}
			k++;
		}
	}
	return NULL;
}

/******************************************************************************

	AdrList_SendMail

	ȈՃAhX̑IĐɃ[

******************************************************************************/

void AdrList_SendMail(HWND hWnd)
{
	int Sel = -1;
	TCHAR buf[256];
	TCHAR* p;
	HWND hAdrList;
//	HTREEITEM hSel;
//	TVITEM tvi;

	hAdrList = GetDlgItem (hWnd, IDC_ADRLIST);
	if (!hAdrList) return;

	// Io
	Sel = ListView_GetNextItem(hAdrList, Sel, LVNI_SELECTED);
	if (Sel == -1){
		return;
	}
//	hSel = TreeView_GetSelection(hAdrList);
//	if (hSel == NULL){
//		return;
//	}

	// e[u̔ԍ
//	memset (&tvi, 0, sizeof(tvi));
//	tvi.mask = TVIF_PARAM;
//	tvi.hItem = hSel;
//	TreeView_GetItem(hAdrList, &tvi);
//	Sel = tvi.lParam;
	Sel = ListView_GetlParam(hAdrList, Sel);

	p = AdrList_GetAddress (Sel);
	if (p == NULL) return;

	lstrcpy (buf, p);

	// [M_CAO
	if(Edit_MailToSet(hInst, MainWnd, buf, -1) == TRUE){
	}
}

/******************************************************************************

	AdrList_NotifyProc

	c[r[Cxg

******************************************************************************/

LRESULT AdrList_NotifyProc(HWND hWnd, LPARAM lParam)
{
	NM_TREEVIEW* ptv = (NM_TREEVIEW *)lParam;
	NMHDR *CForm = (NMHDR *)lParam;

	switch(ptv->hdr.code)
	{
	case TVN_SELCHANGED:		//ACȇIԂ̕ύX
		return FALSE;
	}

	switch(CForm->code)
	{
	case NM_CLICK:				//NbN
		return FALSE;
	case NM_DBLCLK:				//_uNbN
		AdrList_SendMail(hWnd);
		return FALSE;

	case NM_RCLICK:				//ENbN
		SendMessage(hWnd, WM_COMMAND, ID_MENU_ADDR, 0);
		return FALSE;
	}
	return FALSE;
}

/* End of source */
