/**************************************************************************

	nPOP-Q

	EditView.c

	(C) Copyright 1999-2002 By Qta Sakamoto. All right reserved.

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include "General.h"
#include "Options.h"

static void SetEditSubClass(HWND hWnd);
static WNDPROC EditWindowProcedure;

static struct TPMULTIPART **tpMultiPart;
static int MultiPartCnt;

static int EditMaxLength = 30000;

#define ID_CLICK_TIMER	4444
#define ID_CLICK_TIMER2	4445

#ifdef _UNICODE
#define	tstrncmp	wcsncmp
#else
#define	tstrncmp	strncmp
#endif

/**************************************************************************
	Global Variables
**************************************************************************/

//OQ
extern HINSTANCE hInst;
extern struct TPMAILBOX *MailBox;
extern int MailBoxCnt;
extern HFONT hEditFont;

extern HWND g_hListView;
extern HWND g_hEditView;

extern int SelBox;
extern TCHAR *URLApp;

/*
#include <richedit.h>

BOOL SetInitialFont(HWND hEdit)//ŏ̃tHg̐ݒ
{
	CHARFORMAT cfm;
	memset(&cfm, 0, sizeof(CHARFORMAT));

	cfm.cbSize = sizeof(CHARFORMAT);
	cfm.dwMask = CFM_BOLD | CFM_CHARSET | CFM_COLOR |
		CFM_FACE | CFM_ITALIC | CFM_SIZE | CFM_STRIKEOUT |
		CFM_UNDERLINE;
//	dwMyMask = cfm.dwMask;
	cfm.bCharSet = SHIFTJIS_CHARSET;
//	cfm.yHeight = 18;
	strcpy(cfm.szFaceName, "lr SVbN");
	if (SendMessage(hEdit, EM_SETCHARFORMAT, SCF_SELECTION | SCF_WORD,
		(LPARAM)&cfm) == 0) {
		return FALSE;
	}
	return TRUE; 
}
*/
/******************************************************************************

	CreateEditView

	Tvr[̍쐬Ə

******************************************************************************/

HWND CreateEditView(HWND hWnd)
{
	RECT rcClient;
	HWND hEditView;
//	HINSTANCE hRtLib;

	GetClientRect(hWnd, &rcClient);

//	hRtLib = LoadLibrary("RICHED32.DLL");
//	hEditView = CreateWindowEx(WS_EX_CLIENTEDGE,TEXT("RICHEDIT"),TEXT(""),
//		WS_CHILD | WS_VISIBLE | WS_BORDER | ES_MULTILINE | WS_VSCROLL | WS_HSCROLL | ES_AUTOVSCROLL | ES_AUTOHSCROLL,
//		0, 0, 0, 0,
//		hWnd, (HMENU)IDC_EDITVIEW, hInst, NULL);
//	if (hEditView == NULL) {
#ifdef _WIN32_WCE_PPC
	hEditView = CreateWindowEx(0, TEXT("EDIT"), TEXT(""),
		WS_VISIBLE | WS_CHILD | ES_MULTILINE | WS_VSCROLL | WS_BORDER,
		0, 0, 0, 0,
		hWnd, (HMENU)IDC_EDITVIEW, hInst, NULL);
#else
	hEditView = CreateWindowEx(WS_EX_CLIENTEDGE, TEXT("EDIT"), TEXT(""),
		WS_VISIBLE | WS_CHILD | ES_MULTILINE | WS_VSCROLL,
		0, 0, 0, 0,
		hWnd, (HMENU)IDC_EDITVIEW, hInst, NULL);
#endif
//	}
//	else {
//		SetInitialFont(hEditView);
//	}

	if(hEditView == NULL){
		return NULL;
	}

	SendMessage(hEditView, WM_SETFONT, (WPARAM)hEditFont, MAKELPARAM(TRUE,0));

	SetEditSubClass(hEditView);

	tpMultiPart  = NULL;
	MultiPartCnt = 0;

#ifdef _WIN32_WCE
	EditMaxLength = EDITMAXSIZE / sizeof(TCHAR);
#else
	{
		OSVERSIONINFO os_info;
		os_info.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
		GetVersionEx(&os_info);
		EditMaxLength = (os_info.dwPlatformId == VER_PLATFORM_WIN32_NT) ? 0 : (EDITMAXSIZE / sizeof(TCHAR));
	}
#endif
	SendMessage(hEditView, EM_LIMITTEXT, (WPARAM)EditMaxLength, 0);

	return hEditView;
}

/******************************************************************************

	EditView_RestNo

	vr[ɕ\Ăf[^ʒuZbg

******************************************************************************/
static int s_BeforBox = -1;
static int s_BeforNo  = -1;

void EditView_RestNo ()
{
	s_BeforBox = -1;
	s_BeforNo  = -1;
}

void EditView_RestNo2 (HWND hWnd)
{
	if (SelBox >= MAILBOX_USER && s_BeforBox == SelBox) {
		s_BeforNo  = -1;
		EditView_SetText (hWnd, SelBox);
	}
}

/******************************************************************************

	EditView_SetText

	vr[EChEɕ\

******************************************************************************/
void EditView_SetText(HWND hWnd, int SelBox)
{
	TCHAR* body;
	TCHAR* buf;
	int TextIndex = -1;
	int OptLen;
	int BodyLen;
	int itemno;
	struct TPMAILITEM* tpMailItem;

	if (g_hListView == NULL) return;
	if (g_hEditView == NULL) return;

	itemno = ListView_GetNextItem(g_hListView, -1, LVNI_FOCUSED);
	if(itemno < 0) {
		SetWindowText (g_hEditView, TEXT(""));
		EditView_RestNo ();
		return;
	}

	if (s_BeforBox == SelBox && s_BeforNo == itemno) return;

	s_BeforBox = SelBox;
	s_BeforNo  = itemno;

	SetWindowText (g_hEditView, TEXT(""));

	ListView_EnsureVisible(g_hListView, itemno, TRUE);

	tpMailItem = (struct TPMAILITEM *)ListView_GetlParam(g_hListView, itemno);
	if(tpMailItem == NULL || tpMailItem->Body == NULL) {
		return;
	}

	//}`p[g̓WJ
	tpMultiPart  = NULL;
	MultiPartCnt = 0;
	BodyLen = 0;
	body = BodyDecode(tpMailItem, FALSE, &tpMultiPart, &MultiPartCnt);
	if (body) BodyLen = lstrlen(body);

	if (tpMultiPart)
		FreeMultipartInfo(&tpMultiPart, MultiPartCnt);

	//TvɃwb_[̈ꕔ\邽߂̃TCYvZ
	OptLen = 0;
	if (tpMailItem->From    != NULL) OptLen += lstrlen (tpMailItem->From   ) + 16;
	if (tpMailItem->To      != NULL) OptLen += lstrlen (tpMailItem->To     ) + 16;
	if (tpMailItem->Cc      != NULL) OptLen += lstrlen (tpMailItem->Cc     ) + 16;
	if (tpMailItem->Bcc     != NULL) OptLen += lstrlen (tpMailItem->Bcc    ) + 16;
	if (tpMailItem->Date    != NULL) OptLen += lstrlen (tpMailItem->Date   ) + 16;
	if (tpMailItem->Subject != NULL) OptLen += lstrlen (tpMailItem->Subject) + 16;
	if (tpMailItem->ReplyTo != NULL) OptLen += lstrlen (tpMailItem->ReplyTo) + 16;
	if (tpMailItem->XMailer != NULL) OptLen += lstrlen (tpMailItem->XMailer) + 16;
	if (tpMailItem->Received != NULL) OptLen += lstrlen (tpMailItem->Received) + 16;

	if (body == NULL) {
		buf = (TCHAR *)LocalAlloc(LMEM_FIXED, sizeof(TCHAR) * (1 + OptLen + 32));
	}
	else {
		buf = (TCHAR *)LocalAlloc(LMEM_FIXED, sizeof(TCHAR) * (BodyLen + 1 + OptLen + 32));
	}

	if(buf != NULL){
		//wb_̕\
		OptLen = 0;
		if (tpMailItem->From    != NULL && g_Winpos.fEvHead[0]) {
			tsprintf (&buf[OptLen], TEXT("From    : %s\r\n"), tpMailItem->From   );
			OptLen += lstrlen (&buf[OptLen]);
		}
		if (tpMailItem->To      != NULL && g_Winpos.fEvHead[1]) {
			tsprintf (&buf[OptLen], TEXT("To      : %s\r\n"), tpMailItem->To     );
			OptLen += lstrlen (&buf[OptLen]);
		}
		if (tpMailItem->Cc      != NULL && g_Winpos.fEvHead[2]) {
			tsprintf (&buf[OptLen], TEXT("CC      : %s\r\n"), tpMailItem->Cc     );
			OptLen += lstrlen (&buf[OptLen]);
		}
		if (tpMailItem->Bcc     != NULL && g_Winpos.fEvHead[3]) {
			tsprintf (&buf[OptLen], TEXT("BCC     : %s\r\n"), tpMailItem->Bcc    );
			OptLen += lstrlen (&buf[OptLen]);
		}
		if (tpMailItem->Date    != NULL && g_Winpos.fEvHead[4]) {
			tsprintf (&buf[OptLen], TEXT("Date    : %s\r\n"), tpMailItem->Date   );
			OptLen += lstrlen (&buf[OptLen]);
		}
		if (tpMailItem->Subject != NULL && g_Winpos.fEvHead[5]) {
			tsprintf (&buf[OptLen], TEXT("Subject : %s\r\n"), tpMailItem->Subject);
			OptLen += lstrlen (&buf[OptLen]);
		}
		if (tpMailItem->ReplyTo != NULL && g_Winpos.fEvHead[6]) {
			tsprintf (&buf[OptLen], TEXT("ReplyTo : %s\r\n"), tpMailItem->ReplyTo);
			OptLen += lstrlen (&buf[OptLen]);
		}
		if (tpMailItem->XMailer != NULL && g_Winpos.fEvHead[7]) {
			tsprintf (&buf[OptLen], TEXT("X-Mailer: %s\r\n"), tpMailItem->XMailer);
			OptLen += lstrlen (&buf[OptLen]);
		}
		if (tpMailItem->Received != NULL && g_Winpos.fEvHead[8]) {
			tsprintf (&buf[OptLen], TEXT("Received: %s\r\n"), tpMailItem->Received);
			OptLen += lstrlen (&buf[OptLen]);
		}
		//wb_[Ɩ{̊ԂɂPs
		if (OptLen > 0) {
			lstrcpy (&buf[OptLen], TEXT("\r\n"));
			OptLen += lstrlen (&buf[OptLen]);
		}
		//{̕\
		if (body) lstrcpy (&buf[OptLen], body);

		if((sizeof(TCHAR) * (BodyLen+OptLen)) > EDITMAXSIZE){
			*(buf + (EDITMAXSIZE / sizeof(TCHAR))) = TEXT('\0');
		}
		SetWindowText (g_hEditView, buf);
		LocalFree(buf);
	}
	if (body)
		LocalFree(body);

}


/******************************************************************************

	ProgHelpDdeCallback

	DDẼR[obN

******************************************************************************/


#ifndef _WIN32_WCE
static HDDEDATA CALLBACK ProgHelpDdeCallback(UINT wType,UINT wFmt,HCONV hConv,HSZ hsz1,HSZ hsz2,HDDEDATA hData,DWORD dwData1,DWORD dwData2) {
    return 0;
}
#endif


/******************************************************************************

	IEDdeOpenWindow

	IEʃEChEŊJ

******************************************************************************/

#ifdef _WIN32_WCE
int IEDdeOpenWindow (TCHAR* szFileName)
{
	return FALSE;
}
#else
int IEDdeOpenWindow (TCHAR* szFileName)
{
	int rc;
	int ret = FALSE;
	DWORD	idInst = 0;
	HCONV	hConv = 0;
	HSZ 	hszWinapp = 0;
	HSZ 	hszSystem = 0;
	HDDEDATA hData = 0;
    DWORD dwResult;
	TCHAR cmd[MAX_PATH+16];

	rc = DdeInitializeA (&idInst, ProgHelpDdeCallback,
		APPCMD_CLIENTONLY | CBF_SKIP_ALLNOTIFICATIONS,
		0L);
	if (rc != DMLERR_NO_ERROR) {
		return FALSE;
	}

	hszWinapp = DdeCreateStringHandleA(idInst, TEXT("IExplore"), 0);
	hszSystem = DdeCreateStringHandleA(idInst, TEXT("WWW_OpenURL"), 0);
	hConv = DdeConnect(idInst, hszWinapp, hszSystem, NULL);
	if (hszWinapp == NULL || hszSystem == NULL || hConv == NULL) {
		if (hszWinapp) DdeFreeStringHandle(idInst, hszWinapp);
		if (hszSystem) DdeFreeStringHandle(idInst, hszSystem);
		if (idInst) DdeUninitialize(idInst);
		return FALSE;
	}

	wsprintf (cmd, TEXT("\"%s\",,-1,,,,,"), szFileName);
	hData = DdeClientTransaction(
		(PBYTE)cmd, lstrlen(cmd) + 1,
		hConv, 0, 0, XTYP_EXECUTE, TIMEOUT_ASYNC, 
		&dwResult);

	if (hConv) DdeDisconnect(hConv);
	if (hszWinapp) DdeFreeStringHandle(idInst, hszWinapp);
	if (hszSystem) DdeFreeStringHandle(idInst, hszSystem);
	if (idInst) DdeUninitialize(idInst);

	return TRUE;
}
#endif

/******************************************************************************

	ShellOpen

	t@C֘AtŎs

******************************************************************************/

static BOOL ShellOpen(TCHAR *FileName)
{
	SHELLEXECUTEINFO sei;

	if (GetAsyncKeyState(VK_CONTROL) & 0x8000) {
		if (IEDdeOpenWindow (FileName))
			return 0;
	}

	sei.cbSize = sizeof(sei);
	sei.fMask = 0;
	sei.hwnd = NULL;
	sei.lpVerb = NULL;
	if(URLApp == NULL || *URLApp == TEXT('\0')){
		sei.lpFile = FileName;
		sei.lpParameters = NULL;
	}else{
		sei.lpFile = URLApp;
		sei.lpParameters = FileName;
	}
	sei.lpDirectory = NULL;
	sei.nShow = SW_SHOWNORMAL;
	sei.hInstApp = hInst;
	return ShellExecuteEx(&sei);
}


/******************************************************************************

	MbsLen

	Ch}`oCgɕϊ (XPΉ)

******************************************************************************/

#ifndef _WIN32_WCE
int MbsLen(TCHAR* buf, int len, int cur)
{
	OSVERSIONINFO ver;
	ver.dwOSVersionInfoSize = sizeof(ver);
	GetVersionEx(&ver);

	if (ver.dwMajorVersion >= 5 && ver.dwMinorVersion >= 1) {
		BYTE* q;
		int pos = 0;
		for (q = buf; q < (buf + len); q++) {
			if (pos == cur) break;
			if ((*q >= 0x80 && *q <= 0x9f)||(*q >= 0xe0 && *q <= 0xff))
				q++;
			pos++;
		}
		cur = (q - buf);
	}
	return cur;
}

/******************************************************************************

	WcsLen

	}`oCgChɕϊ (XPΉ)

******************************************************************************/

int WcsLen(TCHAR* buf, int len, int cur)
{
	OSVERSIONINFO ver;
	ver.dwOSVersionInfoSize = sizeof(ver);
	GetVersionEx(&ver);

	if (ver.dwMajorVersion >= 5 && ver.dwMinorVersion >= 1) {
		BYTE* q;
		int pos = 0;
		for (q = buf; q < (buf + len); q++) {
			if (cur <= (q - buf)) break;
			if ((*q >= 0x80 && *q <= 0x9f)||(*q >= 0xe0 && *q <= 0xff))
				q++;
			pos++;
		}
		return pos;
	}
	return cur;
}
#endif

/******************************************************************************

	OpenURLEx

	GfBbg{bNXIꂽURL𒊏oĊJ

******************************************************************************/

void OpenURLEx(HWND hWnd, BOOL bExec, int cur)
{
	TCHAR *buf;
	TCHAR *str;
	TCHAR *p, *r, *s;
	int i, j;
	int len;
	int MailToFlag = 0;
	BOOL bDot = FALSE;

	//GfBbg{bNX̑Iʒu̎擾
	if (bExec) {
		SendMessage(hWnd, EM_GETSEL, (WPARAM)&i, (LPARAM)&j);
		if(i >= j){
			return;
		}
	}

	//GfBbg{bNXɐݒ肳ꂽ̎擾
	len = SendMessage(hWnd, WM_GETTEXTLENGTH, 0, 0) + 1;
	buf = (TCHAR *)LocalAlloc(LMEM_FIXED, sizeof(TCHAR) * (len + 1 + 32));
	if(buf == NULL){
		return;
	}
	*buf = TEXT('\0');
	SendMessage(hWnd, WM_GETTEXT, len, (LPARAM)buf);

	//I
	if (!bExec) {
#ifndef _WIN32_WCE
		cur = MbsLen(buf, len, cur);
#endif
		if (cur > len) {
			LocalFree(buf);
			return;
		}
		i = 0;
		for(p = buf + cur; p > buf ;p--){
			if (*p == TEXT('.')) bDot = TRUE;
			if (*p <= TEXT(' ')) break;
			i = (p - buf);
			if (tstrncmp(p,TEXT("http"),4) == 0) break;
		}
		j = 0;
		for(p = buf + cur; p < (buf + len + 1) ;p++){
			if (*p == TEXT('.')) bDot = TRUE;
			if (*p <= TEXT(' ')) break;
			if (*p == TEXT(')')) break;
			j = (p - buf) + 1;
		}
	}
	else {
#ifndef _WIN32_WCE
		i = MbsLen(buf, len, i);
		j = MbsLen(buf, len, j);
#endif
	}
	if(i >= j){
		LocalFree(buf);
		return;
	}

	str = (TCHAR *)LocalAlloc(LMEM_FIXED, sizeof(TCHAR) * (j - i + 2 + 32));
	if(str == NULL){
		LocalFree(buf);
		return;
	}

	//I𕶎̒o
	for(p = buf + i, r = str;p < (buf + j);p++, r++){
		*r = *p;
	}
	*r = TEXT('\0');

	//S~̏
	for(s = str;*s == TEXT('(') || *s == TEXT(')') || *s == TEXT('\"') ||
		*s == TEXT('<') || *s == TEXT('>') || *s == TEXT('\t') || *s == TEXT(' ');s++);
	for(p = s;*p != TEXT('\0');p++){
		if(*p == TEXT('(') || *p == TEXT(')') || *p == TEXT('\"') ||
			*p == TEXT('<') || *p == TEXT('>') ||
			*p == TEXT('\r') || *p == TEXT('\n') || *p == TEXT('\t') ||
			*p == TEXT(' ')){ // || IsLeadChar(*p) == TRUE){
			*p = TEXT('\0');
			break;
		}
		if(*p == TEXT('@')){
			if(MailToFlag != 0){
				MailToFlag = -1;
			}else{
				MailToFlag = 1;
			}
		}
	}
	if(*s == TEXT('\0')){
		LocalFree(buf);
		LocalFree(str);
		return;
	}

	//URL̃`FbN
	if (bExec) {
		if(TStrCmpNI(s, URL_HTTP, lstrlen(URL_HTTP)) == 0 ||
			TStrCmpNI(s, URL_HTTPS, lstrlen(URL_HTTPS)) == 0 ||
			TStrCmpNI(s, URL_FTP, lstrlen(URL_FTP)) == 0){
			SendMessage(hWnd, EM_SETSEL, (WPARAM)i, (LPARAM)i);
			ShellOpen(s);
		}else if(TStrCmpNI(s, URL_MAILTO, lstrlen(URL_MAILTO)) == 0 ||
			MailToFlag == 1){
			SendMessage(hWnd, EM_SETSEL, (WPARAM)i, (LPARAM)i);
			if(Edit_MailToSet(hInst, GetParent(hWnd), s, SelBox) == TRUE){
#ifdef _WIN32_WCE
#ifndef _CENET
				ShowWindow(hWnd, SW_HIDE);
#endif
#endif
			}
		}
	}
	else {
#ifndef _WIN32_WCE
		i = WcsLen(buf, len, i);
		j = WcsLen(buf, len, j);
#endif
		if (bDot) SendMessage(hWnd, EM_SETSEL, (WPARAM)i, (LPARAM)j);
	}
	LocalFree(buf);
	LocalFree(str);
}

/******************************************************************************

	SubClassEditProc

	TuNXEBhEvV[W

******************************************************************************/

static LRESULT CALLBACK SubClassEditProc(HWND hWnd, UINT msg, WPARAM wParam,LPARAM lParam)
{
	static WPARAM s_lParam = 0;

	switch(msg)
	{
	case WM_TIMER:
		switch(wParam)
		{
		case ID_CLICK_TIMER:
			KillTimer(hWnd, wParam);
			{
				int cur;
				DWORD  dwcur;
				lParam = s_lParam;
				dwcur = SendMessage(hWnd, EM_CHARFROMPOS, 0, lParam);
				cur = LOWORD(dwcur);
				OpenURLEx(hWnd,TRUE,cur);
			}
			break;
		case ID_CLICK_TIMER2:
			KillTimer(hWnd, wParam);
			{
				int cur;
				DWORD  dwcur;
				lParam = s_lParam;
				dwcur = SendMessage(hWnd, EM_CHARFROMPOS, 0, lParam);
				cur = LOWORD(dwcur);
				OpenURLEx(hWnd,FALSE,cur);
			}
			break;
		}
		break;

	case WM_LBUTTONUP:
		s_lParam = lParam;
		SetTimer(hWnd, ID_CLICK_TIMER2, 100, NULL);
		break;

	case WM_LBUTTONDBLCLK:
		SetTimer(hWnd, ID_CLICK_TIMER, 500, NULL);
		break;

	case WM_CHAR:
	case WM_DEADCHAR:
//	case WM_CUT:
//	case WM_CLEAR:
//	case WM_PASTE:
//	case EM_UNDO:
		return 0;
	}
	return CallWindowProc(EditWindowProcedure, hWnd, msg, wParam, lParam);
}


/******************************************************************************

	SetEditSubClass

	EBhẼTuNX

******************************************************************************/

static void SetEditSubClass(HWND hWnd)
{
	SendMessage(hWnd, EM_LIMITTEXT, 1, 0);
	EditWindowProcedure = (WNDPROC)SetWindowLong(hWnd, GWL_WNDPROC, (long)SubClassEditProc);
}


void DelEditSubClass(HWND hWnd)
{
	SetWindowLong(hWnd, GWL_WNDPROC, (long)EditWindowProcedure);
	EditWindowProcedure = NULL;
}

/******************************************************************************

	EditView_NextMail

	̃[\

******************************************************************************/

int EditView_NextMail (HWND hWnd)
{
	extern HWND g_hListView;
	struct TPMAILITEM *tpMailItem;
	int i;
	if(SelBox == MAILBOX_SEND){
		return FALSE;
	}
	if(ListView_GetSelectedCount(g_hListView) <= 0){
		return FALSE;
	}
	i = ListView_GetNextItem(g_hListView, -1, LVNI_FOCUSED);
	if(i == -1){
		return FALSE;
	}
	i = ListView_GetNextMailItem(g_hListView, i);
	if(i == -1){
		return FALSE;
	}
	tpMailItem = (struct TPMAILITEM *)ListView_GetlParam(g_hListView, i);
	if(tpMailItem == NULL){
		return FALSE;
	}
	ListView_SetItemState(g_hListView, -1, 0, LVIS_SELECTED);
	ListView_SetItemState(g_hListView,
		i, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);
	ListView_EnsureVisible(g_hListView, i, TRUE);

	return TRUE;
}

/******************************************************************************

	EditView_PrevMail

	̃[\

******************************************************************************/

int EditView_PrevMail (HWND hWnd)
{
	extern HWND g_hListView;
	struct TPMAILITEM *tpMailItem;
	int i;
	if(SelBox == MAILBOX_SEND){
		return FALSE;
	}
	if(ListView_GetSelectedCount(g_hListView) <= 0){
		return FALSE;
	}
	i = ListView_GetNextItem(g_hListView, -1, LVNI_FOCUSED);
	if(i == -1){
		return FALSE;
	}
	i = ListView_GetPrevMailItem(g_hListView, i);
	if(i == -1){
		return FALSE;
	}
	tpMailItem = (struct TPMAILITEM *)ListView_GetlParam(g_hListView, i);
	if(tpMailItem == NULL){
		return FALSE;
	}
	ListView_SetItemState(g_hListView, -1, 0, LVIS_SELECTED);
	ListView_SetItemState(g_hListView,
		i, LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);
	ListView_EnsureVisible(g_hListView, i, TRUE);

	return TRUE;
}
/* End of source */
