/**************************************************************************

	CDQ Library
	(C) Copyright 2002 By Qta. All right reserved.

**************************************************************************/
#include "General.h"

#if defined(_POSTPET) || defined(_WIN32_WCE_PPC)
//#include <windows.h>
//#include <commctrl.h>
#include "FileDialog.h"
//#include "resource.h"

//extern "C" {
extern HINSTANCE hInst;				//CX^XEnh
//};

#ifndef UNICODE
#define wcschr		strchr
#define wcsrchr 	strrchr
#define wcsicmp 	stricmp
#endif

#ifdef JPN
#define STR_SPF_NEWFOLDER			_T("V̫")
#define STR_SPF_NEWFOLDERN			_T("V̫#%d")
#define STR_TAG_NAME				_T("O");
#define STR_TAG_SIZE				_T("TCY");
#define STR_TAG_DATE				_T("t");
#else
#define STR_SPF_NEWFOLDER			_T("NewFolder")
#define STR_SPF_NEWFOLDERN			_T("NewFolder#%d")
#define STR_TAG_NAME				_T("Name");
#define STR_TAG_SIZE				_T("Size");
#define STR_TAG_DATE				_T("Date");
#endif

struct COD od;

//------------------------------------------------
//EFCgEJ[\ݒ
//------------------------------------------------
static void SetWaitCursor (int fWait)
{
	static int fNow = FALSE;

	if (fNow && fWait)
		return;

	if (fWait) {
		fNow = TRUE;
		SetCursor(LoadCursor(NULL, IDC_WAIT));
	}
	else {
		fNow = FALSE;
		SetCursor(NULL);
	}
}

//------------------------------------------------
//t@C݂̑mF
//------------------------------------------------
static int AccessFile (TCHAR* cFileName)
{
	HANDLE ff;
	WIN32_FIND_DATA wfd;

	ff = FindFirstFile (cFileName, &wfd);
	if (ff == INVALID_HANDLE_VALUE)
		return 0;

	FindClose (ff);

	if (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ||
		wfd.dwFileAttributes & FILE_ATTRIBUTE_TEMPORARY) {
		return 2;
	}

	return 1;
}

//------------------------------------------------
//------------------------------------------------
static int MsgWndProc ()
{
	MSG msg;
	int i;
	for (i = 0; i < 32; i++) {
		if (PeekMessage (&msg, NULL, 0, 0, PM_REMOVE)) {
			TranslateMessage(&msg);
			DispatchMessage (&msg);
		}
		else {
			break;
		}
	}
	return FALSE;
}

//------------------------------------------------
static void COD_Init(void)
{
	od.m_fFolder   = 0;
	od.m_fLabelEd  = 0;
	od.m_nIndex    = 0;

	lstrcpy (od.m_cFileName, TEXT(""));
	lstrcpy (od.m_cPathName, TEXT(""));
	lstrcpy (od.m_cMaskName, TEXT("*.*"));
	lstrcpy (od.m_cSaveName, TEXT("noname.txt"));
	od.m_lpTitle = TEXT("File");

	od.m_hImgList = 0;
	od.m_hToolBar = 0;
}

//---------------------------------------------------------------
// R{{bNX\
static void OpenDlg_InsertCombox (HWND hDlg)
{
	int i;
	TCHAR* p;
	TCHAR* s;
	TCHAR buf[MAX_PATH];
	int iIndex = 0;

	HWND hItem;
	hItem = GetDlgItem (hDlg, IDC_COMBO1);
	if (hItem == 0) return;

	SendMessage (hItem, CB_RESETCONTENT, 0, 0);
	lstrcpy (buf, TEXT("\\"));
	SendMessage (hItem, CB_INSERTSTRING, iIndex, (LPARAM)buf);
	iIndex++;

	s = &od.m_cPathName[1];
	while (1) {
		p = wcschr (s, TEXT('\\'));
		if (p == 0) break;

		for (i = 0; i < iIndex+1; i++) {
			buf[i] = TEXT(' ');
			buf[i+1] = 0;
		}

		for (i = 0; s != p; i++) {
			buf[i+iIndex] = *s;
			s++;
		}
		buf[i+iIndex] = 0;
		s = p + 1;

		SendMessage (hItem, CB_INSERTSTRING, iIndex, (LPARAM)buf);
		iIndex++;
	}

	SendMessage (hItem, CB_SELECTSTRING, 0, (LPARAM)buf);
}

//---------------------------------------------------------------
//t@CXg\
static void OpenDlg_InsertColumn (HWND hItem)
{
    LVCOLUMN lvcol;

    lvcol.mask     = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
    lvcol.fmt      = LVCFMT_LEFT;
    lvcol.cx       = 120;
    lvcol.pszText  = STR_TAG_NAME;
    lvcol.iSubItem = 0;
	ListView_InsertColumn (hItem, 0, &lvcol);

    lvcol.cx       = 70;
    lvcol.fmt      = LVCFMT_RIGHT;
    lvcol.pszText  = STR_TAG_SIZE;
    lvcol.iSubItem = 1;
    ListView_InsertColumn (hItem, 1, &lvcol);

    lvcol.cx       = 136;
    lvcol.fmt      = LVCFMT_LEFT;
    lvcol.pszText  = STR_TAG_DATE;
    lvcol.iSubItem = 2;
    ListView_InsertColumn (hItem, 2, &lvcol);

    return;
}

//---------------------------------------------------------------
static HICON OpenDlg_GetIcon (TCHAR* cFileName)
{
	SHFILEINFO sfi;
	memset( &sfi, 0, sizeof(sfi));

	if (SHGetFileInfo(cFileName, 0, &sfi, sizeof(sfi), SHGFI_ICON|SHGFI_SMALLICON)) {
		if (sfi.hIcon != 0) {
			return sfi.hIcon;
		}
	}

	return 0;
}

//---------------------------------------------------------------
static void OpenDlg_InsertData (HWND hItem, TCHAR* pszText1, TCHAR* pszText2, TCHAR* pszText3, DWORD lParam)
{
	int nCount;
	int iImage = 0;
	LVITEM li;
	int iIndex;

	nCount = ListView_GetItemCount (hItem);

	if (lParam & FILE_ATTRIBUTE_DIRECTORY ||
		lParam & FILE_ATTRIBUTE_TEMPORARY) {
		iImage = 1;
	}

	memset(&li, 0, sizeof(LVITEM));

	li.mask       = LVIF_TEXT | LVIF_PARAM;
	if (iImage != -1) li.mask |= LVIF_IMAGE;
    li.iItem      = nCount;
    li.iSubItem   = 0;
	li.pszText    = pszText1;
	li.cchTextMax = lstrlen (li.pszText) + 1;
	li.lParam     = lParam;
	li.iImage     = iImage;
	iIndex = ListView_InsertItem (hItem, &li);

    li.mask       = LVIF_TEXT;
    li.iItem      = iIndex;
	li.iSubItem   = 1;
    li.pszText    = pszText2;
	li.cchTextMax = lstrlen (li.pszText) + 1;
	ListView_SetItem (hItem, &li);

    li.mask       = LVIF_TEXT;
    li.iItem      = iIndex;
	li.iSubItem   = 2;
    li.pszText    = pszText3;
	li.cchTextMax = lstrlen (li.pszText) + 1;
	ListView_SetItem (hItem, &li);
}

//---------------------------------------------------------------
//XgɈꗗ\
static int OpenDlg_InsertList (HWND hItem)
{
	int rc;
	HANDLE ff;
	WIN32_FIND_DATA wfd;
	TCHAR cFindName[MAX_PATH];
	TCHAR siz[32];
	TCHAR day[32];
	SYSTEMTIME st;
	FILETIME   ft;
	DWORD dwSize;

	ListView_DeleteAllItems (hItem);

	wsprintf (cFindName, TEXT("%s*.*"), od.m_cPathName);

	ff = FindFirstFile (cFindName, &wfd);
	if (ff == INVALID_HANDLE_VALUE) {
		return FALSE;
	}

	SetWaitCursor (TRUE);
	while (1) {
		if (od.m_fFolder) {
			if ((wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0 &&
				(wfd.dwFileAttributes & FILE_ATTRIBUTE_TEMPORARY) == 0) {
				rc = FindNextFile (ff, &wfd);
				if (rc == 0) break;
				continue;
			}
		}
		if (wfd.cFileName[0] != TEXT('.')) {
			if ((wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0 &&
				(wfd.dwFileAttributes & FILE_ATTRIBUTE_TEMPORARY) == 0) {
				if (wfd.nFileSizeLow < 10000) {
					wsprintf (siz, TEXT("%d"), wfd.nFileSizeLow);
				}
				else if (wfd.nFileSizeLow < 1000000) {
					wsprintf (siz, TEXT("%dKB"), wfd.nFileSizeLow/1000);
				}
				else if (wfd.nFileSizeLow < 100000000) {
					dwSize = wfd.nFileSizeLow / 1000;
					wsprintf (siz, TEXT("%d,%03dKB"), dwSize / 1000, dwSize % 1000);
				}
				else {
					dwSize = wfd.nFileSizeLow / 1000000;
					wsprintf (siz, TEXT("%dMB"), dwSize);
				}
			}
			else {
				siz[0] = 0;
			}
			FileTimeToLocalFileTime (&wfd.ftLastWriteTime, &ft);
			FileTimeToSystemTime (&ft, &st);
			wsprintf (day, TEXT("%04d-%02d-%02d %02d:%02d:%02d"), 
				st.wYear, st.wMonth, st.wDay,
				st.wHour, st.wMinute, st.wSecond);

			OpenDlg_InsertData (hItem, wfd.cFileName, siz, day, wfd.dwFileAttributes);
		}
		rc = FindNextFile (ff, &wfd);
		if (rc == 0) break;
	}
	SetWaitCursor (FALSE);

	FindClose(ff);

	return TRUE;
}

//---------------------------------------------------------------
static int OnInitDialog (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hItem;
	DWORD dwStyle;
	int iSize;
	HICON hicon;
	RECT rctwork;
	SIZE size = {240, 240-26};
	POINT view = {0,0};

#if _POCKETPC
	SHINITDLGINFO shidi;

	TBBUTTON tbButton[] = {
		{0,	0,			TBSTATE_ENABLED,	TBSTYLE_SEP,	0, 0, 0, -1},
		{0,	IDM_UPDIR,	TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{0,	0,			TBSTATE_ENABLED,	TBSTYLE_SEP,	0, 0, 0, -1},
		{2,	IDM_LIST,	TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
		{3,	IDM_REPORT,	TBSTATE_ENABLED,	TBSTYLE_BUTTON,	0, 0, 0, -1},
	};

	SHMENUBARINFO mbi;
	memset (&mbi, 0, sizeof (SHMENUBARINFO));
	mbi.cbSize     = sizeof (SHMENUBARINFO);
	mbi.hwndParent = hDlg;
	mbi.nToolBarId = IDR_MENU_OD;
	mbi.hInstRes   = g_Wif.hInstance;
	mbi.nBmpId     = 0;
	mbi.cBmpImages = 0;
	SHCreateMenuBar(&mbi);

	od.m_hToolBar = mbi.hwndMB;
	CommandBar_AddBitmap   (od.m_hToolBar, hInst, IDB_OPENDLG, 4, 16, 16);
	CommandBar_AddButtons  (od.m_hToolBar, sizeof(tbButton) / sizeof(TBBUTTON), tbButton);
#endif

	hItem = GetDlgItem (hDlg, IDC_LIST1);
	if (hItem) {

	//tCIɂ
	dwStyle = ListView_GetExtendedListViewStyle (hItem);
	dwStyle |= LVS_EX_FULLROWSELECT;
	ListView_SetExtendedListViewStyle(hItem, dwStyle);

	//C[WXg쐬
	iSize = GetSystemMetrics (SM_CXSMICON);
	od.m_hImgList = ImageList_Create (iSize, iSize, ILC_COLOR, 16, 0);
   	ListView_SetImageList (hItem, od.m_hImgList, LVSIL_SMALL);

	hicon = (HICON)LoadImage (hInst, (LPCTSTR)IDI_FILE, IMAGE_ICON, 16, 16, 0);
	if (od.m_hImgList) ImageList_AddIcon (od.m_hImgList, hicon);
	hicon = (HICON)LoadImage (hInst, (LPCTSTR)IDI_FOLDER, IMAGE_ICON, 16, 16, 0);
	if (od.m_hImgList) ImageList_AddIcon (od.m_hImgList, hicon);

	//Jݒ
	OpenDlg_InsertColumn (hItem);

	//Xg\
	OpenDlg_InsertList (hItem);
	}

	//R{{bNX\
	OpenDlg_InsertCombox (hDlg);

	//t@C
	hItem = GetDlgItem (hDlg, IDC_EDIT1);
	if (hItem) SetWindowText (hItem, od.m_cFileName);

	//^Cg
	SetWindowText (hDlg, od.m_lpTitle);

	//EChETCY
	SystemParametersInfo (SPI_GETWORKAREA, 0, &rctwork, 0);
//	SIZE size = {240, 240-26};
	if (rctwork.right >= 320) size.cx = 320;
	if (rctwork.right >= 480) size.cx = 480;
	if (rctwork.bottom >= 320-26-26) size.cy = 320 - 26 - 26;
//	POINT view = {0,0};
	view.x = (rctwork.right - size.cx) / 2;
	view.y = (rctwork.bottom - size.cy) / 2;
	if (view.y < 26) view.y = 0;
	SetWindowPos (hDlg, HWND_TOP, view.x, view.y, size.cx, size.cy, 0);

#if _POCKETPC
	shidi.dwMask = SHIDIM_FLAGS;
	shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
	shidi.hDlg = hDlg;
	SHInitDialog(&shidi);
#endif
	return TRUE;
}

//---------------------------------------------------------------
static int OnCmdMsgOk (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hItem;
	int rc;

	//t@C
	hItem = GetDlgItem (hDlg, IDC_EDIT1);
	GetWindowText (hItem, od.m_cFileName, MAX_PATH);

	if (od.m_cFileName[0] == 0) return FALSE;

	rc = AccessFile (od.m_cFileName);
	if (od.m_fFolder == 0 && rc == 2) return FALSE;
	if (od.m_fFolder == 1 && rc == 1) return FALSE;

	if (od.m_fLive && rc == 0) return FALSE;

	if (od.m_hToolBar) DestroyWindow (od.m_hToolBar);
	od.m_hToolBar = 0;

	return TRUE;
}

//---------------------------------------------------------------
static int OnCmdNewFoler (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int nCount = 1;
	BOOL bCreate = FALSE;
	TCHAR szNewFolderName[MAX_PATH];
	HWND hItem;
	LVFINDINFO vfi;
	int nIndex;

	while (!bCreate)
	{
		TCHAR szNewFolderPath[MAX_PATH] = _T("");
		if (nCount>1)
			swprintf(szNewFolderName, STR_SPF_NEWFOLDERN, nCount);
		else
			swprintf(szNewFolderName, STR_SPF_NEWFOLDER);

		swprintf(szNewFolderPath, _T("%s%s"), od.m_cPathName, szNewFolderName);

		bCreate = CreateDirectory(szNewFolderPath, NULL);
		nCount++;
		if (nCount > 100) {
			return FALSE;
		}
	}

	hItem = GetDlgItem (hDlg, IDC_LIST1);

	//Xg\
	OpenDlg_InsertList (hItem);

	//R{{bNX\
	OpenDlg_InsertCombox (hDlg);

	//XgI
	memset (&vfi, 0, sizeof(vfi));
	vfi.lParam = LVFI_STRING;
	vfi.psz    = szNewFolderName;
	nIndex = ListView_FindItem (hItem, -1, &vfi);
	if (nIndex > 0) {
		od.m_nIndex = nIndex;
		SetTimer (hDlg, 1, 1000, NULL);
	}
	return TRUE;
}

//---------------------------------------------------------------
static int OnUserProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int nIndex = od.m_nIndex;

	HWND hItem;
	hItem = GetDlgItem (hDlg, IDC_LIST1);
	if (hItem == 0) return TRUE;
	SetFocus (hItem);

	ListView_EnsureVisible (hItem, nIndex, TRUE);

	ListView_SetItemState(hItem, nIndex, LVIS_FOCUSED|LVIS_SELECTED, 
			LVIS_FOCUSED|LVIS_SELECTED);

	ListView_EditLabel (hItem, nIndex);
	return TRUE;
}

//---------------------------------------------------------------
static int OnNotifyDblclk (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hItem;
	int iIndex;
	TCHAR buf[MAX_PATH] = TEXT("");
	LVITEM li;

	hItem = GetDlgItem (hDlg, IDC_LIST1);
	if (hItem == 0) return TRUE;

	iIndex = ListView_GetNextItem (hItem, -1, LVNI_FOCUSED);
	if(iIndex == -1){
		return FALSE;
	}

	memset(&li, 0, sizeof(LVITEM));
	li.mask       = LVIF_TEXT | LVIF_PARAM;
    li.iItem      = iIndex;
    li.iSubItem   = 0;
	li.pszText    = buf; 
    li.cchTextMax = MAX_PATH-1;

	ListView_GetItem (hItem, &li);

	if (li.lParam & FILE_ATTRIBUTE_DIRECTORY ||
		li.lParam & FILE_ATTRIBUTE_TEMPORARY) {
		lstrcat (od.m_cPathName, buf);
		lstrcat (od.m_cPathName, TEXT("\\"));

		//Xg\
		OpenDlg_InsertList (hItem);

		//R{{bNX\
		OpenDlg_InsertCombox (hDlg);
	}
	else {
		PostMessage (hDlg, WM_COMMAND, IDOK, 0);
	}

	return TRUE;
}

//---------------------------------------------------------------
static int OnNotifyClick (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hItem;
	int iIndex;
	TCHAR buf[MAX_PATH] = TEXT("");
	LVITEM li;

	hItem = GetDlgItem (hDlg, IDC_LIST1);
	if (hItem == 0) return TRUE;

	iIndex = ListView_GetNextItem (hItem, -1, LVNI_FOCUSED);
	if(iIndex == -1){
		return FALSE;
	}

	memset(&li, 0, sizeof(LVITEM));
	li.mask       = LVIF_TEXT | LVIF_PARAM;
    li.iItem      = iIndex;
    li.iSubItem   = 0;
	li.pszText    = buf; 
    li.cchTextMax = MAX_PATH-1;
   
	ListView_GetItem (hItem, &li);

	hItem = GetDlgItem (hDlg, IDC_EDIT1);

	if (li.lParam & FILE_ATTRIBUTE_DIRECTORY ||
		li.lParam & FILE_ATTRIBUTE_TEMPORARY) {
		wsprintf (od.m_cFileName, TEXT("%s%s\\%s"), od.m_cPathName, buf, od.m_cSaveName);
	}
	else {
		wsprintf (od.m_cFileName, TEXT("%s%s"), od.m_cPathName, buf);
	}
	SetWindowText (hItem, od.m_cFileName);

	return TRUE;
}

//---------------------------------------------------------------
static int OnCmdDel (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hItem;
	int iIndex;
	TCHAR buf[MAX_PATH] = _T("");
	LVITEM li;
	TCHAR szFileName[MAX_PATH];
	int attr;
	int rc;

	hItem = GetDlgItem (hDlg, IDC_LIST1);

	iIndex = ListView_GetNextItem (hItem, -1, LVNI_FOCUSED);
	if(iIndex == -1){
		return FALSE;
	}

	memset(&li, 0, sizeof(LVITEM));
	li.mask       = LVIF_TEXT;
    li.iItem      = iIndex;
    li.iSubItem   = 0;
	li.pszText    = buf; 
    li.cchTextMax = MAX_PATH-1;
	ListView_GetItem (hItem, &li);

	wsprintf (szFileName, TEXT("%s%s"), od.m_cPathName, buf);
	attr = AccessFile (szFileName);
	if (attr == 0) return FALSE;

	rc = MessageBox (hDlg, buf, _T("Delete ?"), MB_YESNO);
	if (rc == IDYES) {
		if (attr == 1) DeleteFile (szFileName);
		if (attr == 2) RemoveDirectory (szFileName);
	}

	//Xg\
	OpenDlg_InsertList (hItem);

	return TRUE;
}
//---------------------------------------------------------------
static int OnNotify (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	LV_DISPINFO *plv = (LV_DISPINFO *)lParam;
	NMHDR *CForm = (NMHDR *)lParam;
	static TCHAR szOldName[MAX_PATH] = _T("");

	switch (plv->hdr.code) {
	case LVN_ITEMCHANGED:		//ACȇIԂ̕ύX
		return TRUE;

	case LVN_BEGINLABELEDIT:	//O̕ύXJn
		{
			HWND hItem;
			int iIndex;
			LVITEM li;

			hItem = GetDlgItem (hDlg, IDC_LIST1);
			iIndex = ListView_GetNextItem (hItem, -1, LVNI_FOCUSED);
			if(iIndex == -1){
				return FALSE;
			}
			memset(&li, 0, sizeof(LVITEM));
			li.mask       = LVIF_TEXT | LVIF_PARAM;
		    li.iItem      = iIndex;
		    li.iSubItem   = 0;
			li.pszText    = szOldName; 
		    li.cchTextMax = MAX_PATH-1;
			ListView_GetItem (hItem, &li);
			od.m_fLabelEd = TRUE;
		}
		return TRUE;

	case LVN_ENDLABELEDIT:		//O̕ύXI
		od.m_fLabelEd = FALSE;
		if (!plv->item.pszText) return FALSE;
		{
			HWND hItem;
			TCHAR szNewName[MAX_PATH];
			TCHAR szNewPath[MAX_PATH];
			TCHAR szOldPath[MAX_PATH];
			lstrcpy (szNewName,  plv->item.pszText);
			wsprintf(szOldPath, _T("%s\\%s"), od.m_cPathName, szOldName);
			wsprintf(szNewPath, _T("%s\\%s"), od.m_cPathName, szNewName);
			if (MoveFile(szOldPath, szNewPath) != 0) {
			}

			hItem = GetDlgItem (hDlg, IDC_LIST1);
			//Xg\
			OpenDlg_InsertList (hItem);
			//R{{bNX\
			OpenDlg_InsertCombox (hDlg);
		}
		return TRUE;

	case LVN_KEYDOWN:			//L[
		if (od.m_fLabelEd) return FALSE;
		{
			NMLVKEYDOWN* pnkd = (NMLVKEYDOWN*) lParam;
			if (pnkd->wVKey == VK_DELETE) {
				OnCmdDel (hDlg, 0, 0,0);
			}
		}
		return TRUE;
	}

	switch (CForm->code) {
	case NM_DBLCLK:				//_uNbN
		OnNotifyDblclk (hDlg, message, wParam, lParam);
		return TRUE;

	case NM_CLICK:				//NbN
	case NM_RCLICK:				//ENbN
		OnNotifyClick (hDlg, message, wParam, lParam);
		return TRUE;
	}

	return FALSE;
}

//---------------------------------------------------------------
static int OnCmdMsgCombox (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hItem = (HWND)lParam;
	int iIndex;
	iIndex = SendMessage (hItem, CB_GETCURSEL, 0, 0);

	switch  (HIWORD(wParam)) {
	case CBN_SELCHANGE:
		if (iIndex == 0) {
			lstrcpy (od.m_cPathName, TEXT("\\"));
		}
		else {
			TCHAR* p;
			TCHAR* s;
			int iCount = 1;
			s = &od.m_cPathName[1];
			while (1) {
				p = wcschr (s, TEXT('\\'));
				if (p == 0) break;
				s = p + 1;
				if (iCount == iIndex) break;
				iCount++;
			}
			*s = 0;
		}
		hItem = GetDlgItem (hDlg, IDC_EDIT1);
		SetWindowText (hItem, od.m_cPathName);
		//Xg\
		hItem = GetDlgItem (hDlg, IDC_LIST1);
		OpenDlg_InsertList (hItem);
		//R{{bNX\
		OpenDlg_InsertCombox (hDlg);
		break;
	}
	return TRUE; 
}

//---------------------------------------------------------------
static int OnCmdMsgUpdir (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	TCHAR* p;
	int len;
	HWND hItem;

	len = lstrlen (od.m_cPathName);
	if (len > 0) {
		if (od.m_cPathName[len-1] == TEXT('\\'))
			od.m_cPathName[len-1] = 0;
	}

	p = wcsrchr (od.m_cPathName, TEXT('\\'));
	if (p != 0) *(p+1) = 0;

	len = lstrlen (od.m_cPathName);
	if (len > 0) {
		if (od.m_cPathName[len-1] != TEXT('\\'))
			lstrcat (&od.m_cPathName[len], TEXT("\\"));
	}
	else {
		lstrcpy (od.m_cPathName, TEXT("\\"));
	}

	hItem = GetDlgItem (hDlg, IDC_LIST1);

	//Xg\
	OpenDlg_InsertList (hItem);

	//R{{bNX\
	OpenDlg_InsertCombox (hDlg);

	return TRUE; 
}


//---------------------------------------------------------------
static int OnSize (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hItem;
	RECT rect;
	int y;

	GetClientRect (hDlg, &rect);

	y = 4;

//	hItem = GetDlgItem (hDlg, IDC_STITLE);
//	SetWindowPos (hItem, HWND_TOP, 4, y, rect.right-8, 16, 0);
//	y += 16;

	hItem = GetDlgItem (hDlg, IDC_EDIT1);
	if (hItem) SetWindowPos (hItem, HWND_TOP, 4, y, rect.right-8-54, 34, 0);

	hItem = GetDlgItem (hDlg, IDOK);
	if (hItem) SetWindowPos (hItem, HWND_TOP, rect.right-8-48, y, 48, 18, 0);

	hItem = GetDlgItem (hDlg, IDCANCEL);
	if (hItem) SetWindowPos (hItem, HWND_TOP, rect.right-8-48, y+18, 48, 18, 0);

	y += 34 + 4;

	hItem = GetDlgItem (hDlg, IDC_COMBO1);
	if (hItem) SetWindowPos (hItem, HWND_TOP, 4, y, rect.right-8-64, 80, 0);

	hItem = GetDlgItem (hDlg, IDM_UPDIR);
	if (hItem) SetWindowPos (hItem, HWND_TOP, rect.right-8-60, y, 16, 16, 0);

	hItem = GetDlgItem (hDlg, IDM_REPORT);
	if (hItem) SetWindowPos (hItem, HWND_TOP, rect.right-8-60+16, y, 16, 16, 0);

	hItem = GetDlgItem (hDlg, IDM_LIST);
	if (hItem) SetWindowPos (hItem, HWND_TOP, rect.right-8-60+16+16, y, 16, 16, 0);

	hItem = GetDlgItem (hDlg, IDC_CREATE_FOLDER);
	if (hItem) SetWindowPos (hItem, HWND_TOP, rect.right-8-60+16+16+16, y, 16, 16, 0);

	y += 24;

	hItem = GetDlgItem (hDlg, IDC_LIST1);
	if (hItem) SetWindowPos (hItem, HWND_TOP, 4, y, rect.right-8, rect.bottom-y-8, 0);

	return TRUE;
}

//---------------------------------------------------------------
static void OpenDlg_StyleChange (HWND hDlg, DWORD dwNewStyle)
{
	HWND hItem;
	DWORD dwStyle;

	hItem = GetDlgItem (hDlg, IDC_LIST1);

	dwStyle = GetWindowLong(hItem, GWL_STYLE);
	dwStyle &= ~LVS_TYPEMASK;
	dwStyle |= dwNewStyle;
	
	SetWindowLong(hItem, GWL_STYLE, dwStyle);
}

//---------------------------------------------------------------
static int OnCmdMsgReport (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	OpenDlg_StyleChange (hDlg, LVS_REPORT);
	return TRUE;
}

//---------------------------------------------------------------
static int OnCmdMsgList (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	OpenDlg_StyleChange (hDlg, LVS_LIST);
	return TRUE;
}

//---------------------------------------------------------------
static void DrawBits (HDC hDC, int x, int y, int sx, int sy, int cx, int cy)
{
	HDC hVDC = 0;
	HBITMAP hBitmap = 0;
	HBITMAP hBmpold = 0;

	if (!hDC) return;
	//rbg}bv擾
	hBitmap = LoadBitmap (hInst, (LPCTSTR)IDB_MARKS);
	if (!hBitmap) return;
	//ꎞIɂcbɓWJ
	hVDC = CreateCompatibleDC (hDC);
	if (!hVDC) return;
	hBmpold = (HBITMAP) SelectObject (hVDC, hBitmap);
	//zʂɓ\t
	BitBlt (hDC, x,y, cx,cy, hVDC, sx,sy, SRCCOPY);
	//ꎞIȂcbj
	if (hBmpold) SelectObject (hVDC, hBmpold);
	DeleteObject (hBitmap);
	DeleteDC (hVDC);
}

//---------------------------------------------------------------
LRESULT CALLBACK OpenDlg_Proc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
//	static COD* p = 0;
	switch (message)
	{
	case WM_INITDIALOG:
		{
		//	SetWindowLong (hDlg, GWL_USERDATA, (LPARAM)lParam);
		//	COD* p = (COD*)lParam;
		//	if (p == 0) return FALSE;
			//p = (COD*)lParam;
			OnInitDialog (hDlg, message, wParam, lParam);
			OnSize (hDlg, message, wParam, lParam);
		}
		return TRUE;

	case WM_SIZE:
		{
		//	COD* p = (COD*) GetWindowLong (hDlg, GWL_USERDATA);
			OnSize (hDlg, message, wParam, lParam);
		}
		break;
#ifdef _WCE
	case WM_SETTINGCHANGE:
		if (SPI_SETSIPINFO == wParam){
			SHACTIVATEINFO sai;
			memset(&sai, 0, sizeof(SHACTIVATEINFO));
			SHHandleWMSettingChange(hDlg, -1, 0, &sai);
		//	COD* p = (COD*) GetWindowLong (hDlg, GWL_USERDATA);
			OnSize (hDlg, message, wParam, lParam);
		}
		break;
#endif
	case WM_KEYDOWN:
		{
		//	COD* p = (COD*) GetWindowLong (hDlg, GWL_USERDATA);
			if (od.m_fLabelEd) return FALSE;
		}
		break;

	case WM_COMMAND:
		{
		//	COD* p = (COD*) GetWindowLong (hDlg, GWL_USERDATA);
			if (od.m_fLabelEd) return FALSE;

			switch  (LOWORD(wParam)) {
    
			case IDC_COMBO1:
				OnCmdMsgCombox (hDlg, message, wParam, lParam);
				return TRUE;
    
			case IDM_REPORT:
				OnCmdMsgReport (hDlg, message, wParam, lParam);
				return TRUE;
			case IDM_LIST:
				OnCmdMsgList (hDlg, message, wParam, lParam);
				return TRUE;
    
			case IDM_UPDIR:
				OnCmdMsgUpdir (hDlg, message, wParam, lParam);
				return TRUE;

			case IDC_CREATE_FOLDER:
				OnCmdNewFoler (hDlg, message, wParam, lParam);
				return TRUE;
	
			case IDOK:
				if (!OnCmdMsgOk (hDlg, message, wParam, lParam))
					return TRUE;
			case IDCANCEL:
				if (od.m_hImgList) ImageList_Destroy (od.m_hImgList);
				SetWindowLong (hDlg, GWL_USERDATA, (LPARAM)0);
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
		}
		break;

	case WM_NOTIFY:
		{
		//	COD* p = (COD*) GetWindowLong (hDlg, GWL_USERDATA);
			OnNotify (hDlg, message, wParam, lParam);
		}
		return FALSE;

	case WM_DRAWITEM:
		{
			DRAWITEMSTRUCT* dis = (DRAWITEMSTRUCT*)lParam;
			POINT ptLine[] = {
				{dis->rcItem.left   , dis->rcItem.top},
				{dis->rcItem.right-1, dis->rcItem.top},
				{dis->rcItem.right-1, dis->rcItem.bottom-1},
				{dis->rcItem.left   , dis->rcItem.bottom-1},
				{dis->rcItem.left   , dis->rcItem.top},
			};
			switch  (LOWORD(wParam)) {
			case IDM_UPDIR:
				DrawBits (dis->hDC, dis->rcItem.left, dis->rcItem.top, 0, 0, 16, 16);
				break;
			case IDC_CREATE_FOLDER:
				DrawBits (dis->hDC, dis->rcItem.left, dis->rcItem.top, 16, 0, 16, 16);
				break;
			case IDM_LIST:
				DrawBits (dis->hDC, dis->rcItem.left, dis->rcItem.top, 16*2, 0, 16, 16);
				break;
			case IDM_REPORT:
				DrawBits (dis->hDC, dis->rcItem.left, dis->rcItem.top, 16*3, 0, 16, 16);
				break;
			}
			//DrawEdge (dis->hDC, &dis->rcItem, EDGE_RAISED/*BDR_RAISEDOUTER*/, BF_RECT);
			Polyline (dis->hDC, ptLine, sizeof(ptLine)/sizeof(POINT));
		}
		return FALSE;


	case WM_TIMER:
		switch (wParam) {
		case 1:
			KillTimer (hDlg, 1);
		//	COD* p = (COD*) GetWindowLong (hDlg, GWL_USERDATA);
			OnUserProc (hDlg, message, wParam, lParam);
			break;
		}
		return FALSE;
	}

    return FALSE;
}

//---------------------------------------------------------------
static int OpenDlg (HWND hWnd, TCHAR* cFileName)
{
	int rc;
	TCHAR* p;

	if (cFileName[0] != _T('\\')) {
		wsprintf (od.m_cPathName, _T("\\My Documents\\%s"), cFileName);
		wsprintf (od.m_cFileName, _T("\\My Documents\\%s"), cFileName);
	}
	else {
		lstrcpy (od.m_cPathName, cFileName);
		lstrcpy (od.m_cFileName, cFileName);
	}

	if (od.m_cPathName[0] == 0) lstrcpy (od.m_cPathName, TEXT("\\"));

	p = wcsrchr (od.m_cPathName, TEXT('\\'));
	if (p == 0) {
		p = _T("\\");
	}
	else {
		lstrcpy (od.m_cSaveName, (p+1));
	}
	*(p+1) = 0;

	rc = DialogBoxParam (hInst, 
		(LPCTSTR)IDD_FILEDIALOG, hWnd, (DLGPROC)OpenDlg_Proc, (LPARAM)0);

	if (rc == IDOK) {
		lstrcpy (cFileName, od.m_cFileName);
		return rc;
	}
	else
		return rc;
}

//---------------------------------------------------------------
int FolderDialog (HWND hWnd, TCHAR* szTitle, TCHAR* szFileName, int fLive)
{
	int rc;
	COD_Init();
	od.m_fFolder = TRUE;
	od.m_fLive   = fLive;
	od.m_lpTitle = szTitle;
	rc = OpenDlg (hWnd, szFileName);
	return rc;
}

//---------------------------------------------------------------
int FileDialog (HWND hWnd, TCHAR* szTitle, TCHAR* szFileName, int fLive)
{
	int rc;
	COD_Init();
	od.m_lpTitle = szTitle;
	od.m_fLive   = fLive;
	rc = OpenDlg (hWnd, szFileName);
	return rc;
}
//---------------------------------------------------------------
//---------------------------------------------------------------
#endif