/**************************************************************************

	nPOP-Q

	FindItem.c

	(C) Copyright 1999-2002 By Qta Sakamoto. All right reserved.

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include "General.h"
#include "Options.h"

extern HINSTANCE hInst;
extern HWND MainWnd;
extern HWND g_hListView;
extern struct TPMAILBOX *MailBox;
extern int MailBoxCnt;

HWND hFindItem = NULL;

#define ID_MAILITEM_OPEN		(WM_APP + 300)		//[OpenpID

#ifdef _UNICODE
#define	tstrnicmp	wcsnicmp
#else
#define	tstrnicmp	strnicmp
#define wcsrchr 	strrchr
#endif

/******************************************************************************

	FindItem_GetAllCount

	[S𐔂

******************************************************************************/
int FindItem_GetAllCount ()
{
	int iItem;
	int i;
	int j;
	struct TPMAILBOX *tpMailBox;
	struct TPMAILITEM *tpMailItem;

	iItem = 0;
	for (i = 0; i < MailBoxCnt; i++){
		tpMailBox = (MailBox + i);
		if (tpMailBox == NULL) {
			continue;
		}
		for (j = 0; j < tpMailBox->MailItemCnt; j++) {
			tpMailItem = (*(tpMailBox->tpMailItem + j));
			if (tpMailItem == NULL) {
				continue;
			}
			iItem++;
		}
	}
	return iItem;
}


/******************************************************************************

	FindItem_InsertItem

	ʂXgɓo^

******************************************************************************/
int FindItem_InsertItem (HWND hListView, int iItem, struct TPMAILITEM *tpMailItem, int BoxNo, int MailNo)
{
	LV_ITEM lvi;
	TCHAR buf[80];

	lvi.mask = LVIF_TEXT | LVIF_PARAM;
	lvi.iItem = iItem;
	lvi.iSubItem = 0;
	lvi.pszText = tpMailItem->Subject;
	if (lvi.pszText == NULL) lvi.pszText = STR_LIST_NOSUBJECT;
	lvi.cchTextMax = lstrlen(lvi.pszText);
	lvi.iImage = 0;
	lvi.lParam = (LPARAM)tpMailItem;

	ListView_InsertItem(hListView, &lvi);

	if (BoxNo == MAILBOX_SAVE)
		wsprintf (buf, TEXT("%s %d"), STR_SAVEBOX_NAME, BoxNo);
	else if (BoxNo == MAILBOX_SEND)
		wsprintf (buf, TEXT("%s %d"), STR_SENDBOX_NAME, BoxNo);
	else
		wsprintf (buf, TEXT("%s %d"), STR_TREEBOX_NAME, BoxNo);
	ListView_SetItemText(hListView, iItem, 1, buf);

	wsprintf (buf, TEXT("%d"), MailNo);
	ListView_SetItemText(hListView, iItem, 2, buf);

	return 0;
}


/******************************************************************************

	FindItem_CheckString

	obt@̒ɊY镶񂪂邩

******************************************************************************/
int FindItem_CheckString (TCHAR* pszBuf, TCHAR* pszStr, int len)
{
	int i;
	if (pszBuf == NULL || pszStr == NULL)
		return FALSE;
	for (i = 0; pszBuf[i] != 0; i++) {
		if (tstrnicmp(&pszBuf[i],pszStr,len) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}


/******************************************************************************

	FindItem_SeachString

	Y镶񂪂邩[ׂČ

******************************************************************************/
int FindItem_SeachString (HWND hWnd, TCHAR* pszStr)
{
	struct TPMAILBOX *tpMailBox;
	struct TPMAILITEM *tpMailItem;
	TCHAR* body;
	struct TPMULTIPART **tpPart;
	int cnt;
	int rc;
	int len;
	int iItem;
	int i;
	int j;
	int iSeachCnt;
	int iAllCount;
	HWND hText;
	HWND hListView;

	hText = GetDlgItem (hWnd, IDC_TEXT);
	hListView = GetDlgItem (hWnd, IDC_FINDLIST);

	iItem = 0;
	iSeachCnt = 0;
	iAllCount = FindItem_GetAllCount ();

	len = lstrlen(pszStr);
	for (i = 0; i < MailBoxCnt; i++){
		tpMailBox = (MailBox + i);
		if (tpMailBox == NULL) {
			continue;
		}
		for (j = 0; j < tpMailBox->MailItemCnt; j++) {
			tpMailItem = (*(tpMailBox->tpMailItem + j));
			if (tpMailItem == NULL) {
				continue;
			}
			rc = FindItem_CheckString (tpMailItem->From, pszStr, len);
			if (!rc) rc = FindItem_CheckString (tpMailItem->To, pszStr, len);
			if (!rc) rc = FindItem_CheckString (tpMailItem->Subject, pszStr, len);
			if (!rc) {
				tpPart = NULL;
				cnt = 0;
				body = BodyDecode(tpMailItem, FALSE, &tpPart, &cnt);
				if (tpPart)
					FreeMultipartInfo(&tpPart, cnt);
				if (body) {
					rc = FindItem_CheckString (body, pszStr, len);
					LocalFree(body);
				}
			}
			if (rc) {
				FindItem_InsertItem (hListView, iItem, tpMailItem, i, j);
				iItem++;
			}
			iSeachCnt++;
			if (hText) {
				TCHAR buf[80];
				wsprintf (buf, TEXT("Seach : %d/%d"), iSeachCnt, iAllCount);
				SetWindowText (hText, buf);
			}
		}
	}
	if (hText) {
		TCHAR buf[80];
		wsprintf (buf, TEXT("Hit : %d/%d"), iItem, iAllCount);
		SetWindowText (hText, buf);
	}
	return iItem;
}


/******************************************************************************



******************************************************************************/
LRESULT CALLBACK OnInitdialog (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hListView;
	int LvFiColSize[3] = {210,70,40};
	
	hListView = GetDlgItem (hWnd, IDC_FINDLIST);

	ListView_AddColumn(hListView, LVCFMT_LEFT , LvFiColSize[0], TEXT("Subject"), 0);
	ListView_AddColumn(hListView, LVCFMT_LEFT , LvFiColSize[1], TEXT("Box"), 1);
	ListView_AddColumn(hListView, LVCFMT_RIGHT, LvFiColSize[2], TEXT("Mail"), 2);

	return FALSE;
}


/******************************************************************************

	FindItem_OpenMail

	[J

******************************************************************************/

int FindItem_OpenMail (HWND hWnd)
{
	int BoxNo;
	int MailNo;
	TCHAR buf[MAX_PATH];
	int iItem;
	TCHAR* p;
	int SelectItem;
	HWND hList;

	hList = GetDlgItem (hWnd, IDC_FINDLIST);

	iItem = -1;
	iItem = ListView_GetNextItem(hList, iItem, LVNI_SELECTED);
	if (iItem == -1) return FALSE;

	ListView_GetItemText(hList, iItem, 1, buf, sizeof(buf)/sizeof(TCHAR));
	p = wcsrchr(buf,TEXT(' '));
	if (p) p++;
	else p = TEXT("-1");
	BoxNo = _ttoi(p);

	ListView_GetItemText(hList, iItem, 2, buf, sizeof(buf)/sizeof(TCHAR));
	MailNo = _ttoi(buf);
	
	if (BoxNo >= 0 && BoxNo < MailBoxCnt) {
		//R{̑I
		SendDlgItemMessage(MainWnd, IDC_COMBO, CB_SETCURSEL, BoxNo, 0);
		//Xg̑I
		SetFocus(g_hListView);
		SelectMailBox(MainWnd, BoxNo);
		//XgI
		SelectItem = -1;
		while((SelectItem = ListView_GetNextItem(g_hListView, SelectItem, LVNI_SELECTED)) != -1){
			ListView_SetItemState (g_hListView, SelectItem, 0, LVIS_FOCUSED | LVIS_SELECTED);
		}
		//Xg̑I
		ListView_SetItemState (g_hListView, MailNo,
			LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);
		//[J
		SendMessage(MainWnd, WM_COMMAND, ID_MAILITEM_OPEN, 0);
	}
	return TRUE;
}


/******************************************************************************



******************************************************************************/
LRESULT CALLBACK OnCommand (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int id;
	id = LOWORD(wParam);
	switch (id)
	{
	case IDOK:
		{
			TCHAR buf[MAX_PATH];
			HWND hItem;
			int cnt;
			HWND hWndFocus = GetFocus ();
			if (hWndFocus == GetDlgItem (hWnd, IDC_FINDLIST)) {
				FindItem_OpenMail (hWnd);
				break;
			}
			hItem = GetDlgItem (hWnd, IDOK);
			EnableWindow (hItem, FALSE);
			hItem = GetDlgItem (hWnd, IDC_EDIT_FIND);
			EnableWindow (hItem, FALSE);

			hItem = GetDlgItem (hWnd, IDC_EDIT_FIND);
			GetWindowText (hItem, buf, sizeof(buf)/sizeof(TCHAR));

			cnt = FindItem_SeachString (hWnd, buf);

			hItem = GetDlgItem (hWnd, IDOK);
			EnableWindow (hItem, TRUE);
			hItem = GetDlgItem (hWnd, IDC_EDIT_FIND);
			EnableWindow (hItem, TRUE);

			if (cnt) hItem = GetDlgItem (hWnd, IDC_FINDLIST);
			else hItem = GetDlgItem (hWnd, IDC_EDIT_FIND);
			SetFocus (hItem);
		}
		break;

	case IDCANCEL:
		DestroyWindow (hWnd);
		break;

	case IDYES:
		{
			TCHAR buf[32];
			HWND hWndFocus = GetFocus ();
			do {
				hWndFocus = GetWindow(hWndFocus, GW_HWNDNEXT);
				id = GetDlgCtrlID (hWndFocus);
				GetClassName (hWndFocus, buf, sizeof(buf)/sizeof(TCHAR));
				if (tstricmp(buf,TEXT("STATIC")) == 0) id = -1;
			} while (id == -1);
			if (hWndFocus) SetFocus (hWndFocus);
			else SetFocus (GetDlgItem (hWnd, IDC_EDIT_FIND));
		}
		break;
	}
	return FALSE;
}


/******************************************************************************



******************************************************************************/
LRESULT CALLBACK OnNotify (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hList;
	NMHDR *CForm = (NMHDR *)lParam;

	hList = GetDlgItem (hWnd, IDC_FINDLIST);
	if (hList != CForm->hwndFrom)
		return FALSE;
	
	switch(CForm->code)
	{
	case NM_DBLCLK:				//_uNbN
	case NM_RCLICK:				//ENbN
		FindItem_OpenMail (hWnd);
		break;
	}
	return FALSE;
}


/******************************************************************************

	FindItemDlgProc

	EChẼ_CAOvVW

******************************************************************************/
LRESULT CALLBACK FindItemDlgProc (HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		OnInitdialog (hDlg, message, wParam, lParam);
		return TRUE;

	case WM_COMMAND:
		OnCommand (hDlg, message, wParam, lParam);
		break;

	case WM_NOTIFY:
		OnNotify (hDlg, message, wParam, lParam);
		break;

	}
	return FALSE;
}


/******************************************************************************

	FindItem_Dialog

	EChE쐬

******************************************************************************/
HWND FindItem_Dialog (HWND hWnd)
{
	if (hFindItem) {
		if (IsWindow(hFindItem)) {
			ShowWindow (hFindItem, SW_SHOW);
			return hFindItem;
		}
	}
	hFindItem = CreateDialog (hInst, (LPCTSTR)IDD_DIALOG_FINDITEM, 
		hWnd, (DLGPROC)FindItemDlgProc);
	ShowWindow (hFindItem, SW_SHOW);
	return hFindItem;
}
