/**************************************************************************

	nPOP-Q

	Frame.c

	(C) Copyright 1999-2002 By Qta Sakamoto. All right reserved.

**************************************************************************/


/**************************************************************************
	Include Files
**************************************************************************/

#define _INC_OLE
#include <windows.h>
#undef	_INC_OLE

#include "General.h"


/**************************************************************************
	Define
**************************************************************************/

#define NOMOVESIZE		6		//t[̈ړl

#ifdef _WIN32_WCE
#define FRAME_CNT		6		//CEł̓^bvɂ̂ő
#else
#define FRAME_CNT		2
#endif

#define IDC_TB			2001	//main.cŒ`Ɠl

#define IDC_SPLITBAR	2101
HWND hSplit = 0;

/**************************************************************************
	Global Variables
**************************************************************************/

static RECT *FrmRect;			//t[̈ʒu

//OQ
extern HINSTANCE hInst;

/******************************************************************************

	FrameInitialize

	t[`p\̂̏

******************************************************************************/

BOOL FrameInitialize(HWND hWnd)
{
	if(FrmRect == NULL){
		FrmRect = (RECT *)LocalAlloc(LMEM_FIXED, sizeof(RECT) * FRAME_CNT + 32);
		if(FrmRect == NULL){
			return FALSE;
		}
	}
	memset(FrmRect, 0, sizeof(RECT) * FRAME_CNT);

#ifdef _WIN32_WCE
	hSplit = CreateWindowEx(WS_EX_STATICEDGE, TEXT("STATIC"), TEXT(""),
		WS_VISIBLE | WS_CHILD | WS_BORDER,
		0, 0, 0, 0,
		hWnd, (HMENU)IDC_SPLITBAR, hInst, NULL);
#endif

	SetCapture(hWnd);
	return TRUE;
}


/******************************************************************************

	FrameFree

	t[`p\̂̉

******************************************************************************/

void FrameFree(void)
{
	if(FrmRect != NULL){
		LocalFree(FrmRect);
		FrmRect = NULL;
	}

#ifdef _WIN32_WCE
	if (hSplit != NULL) {
		DestroyWindow (hSplit);
		hSplit = 0;
	}
#endif

	ReleaseCapture();
}


/******************************************************************************

	FrameDraw

	ct[̕`

******************************************************************************/

int FrameDraw(HWND hWnd, int x, int y)
{
	RECT WindowRect, TreeViewRect, EditViewRect;
	POINT apos;
	HDC hdc;
	int drawCnt;
	int topsub;

	apos.x = x;
	apos.y = y;
	GetWindowRect(hWnd, (LPRECT)&WindowRect);
	GetWindowRect(GetDlgItem(hWnd, IDC_TREEVIEW), (LPRECT)&TreeViewRect);
	GetWindowRect(GetDlgItem(hWnd, IDC_EDITVIEW), (LPRECT)&EditViewRect);

	//t[̈ړ
#ifdef _WIN32_WCE_PPC
	if(apos.x <= 4){
		apos.x = 4;
#else
	if(apos.x <= WindowRect.left + NOMOVESIZE + GetSystemMetrics(SM_CXEDGE)){
		apos.x = WindowRect.left + NOMOVESIZE + GetSystemMetrics(SM_CXEDGE);
#endif
	}else if(apos.x >= (WindowRect.right - (NOMOVESIZE + (FRAME_CNT * 2)) - GetSystemMetrics(SM_CXEDGE))){
		apos.x = WindowRect.right - (NOMOVESIZE + (FRAME_CNT * 2)) - GetSystemMetrics(SM_CXEDGE);
	}

	//ÖʒuƔr
	if(apos.x == FrmRect[0].left){
		return 1;
	}

#ifdef _CENET
	topsub = 24;
#else
	topsub = 0;
#endif

#ifdef _WIN32_WCE
	SetWindowPos (hSplit, HWND_TOP, 
		apos.x - FRAME_CNT/2,
		TreeViewRect.top - WindowRect.top - topsub,
		FRAME_CNT,
		EditViewRect.bottom - TreeViewRect.top,
		SWP_SHOWWINDOW);

	hdc = GetWindowDC(hSplit);
#else
	hdc = GetWindowDC(hWnd);
#endif

	//O`敪
//#ifndef _WIN32_WCE
	for(drawCnt = 0;drawCnt < FRAME_CNT;drawCnt++){
		DrawFocusRect(hdc, (LPRECT)&FrmRect[drawCnt]);
	}
//#endif

	//t[̕`
	for(drawCnt = 0;drawCnt < FRAME_CNT;drawCnt++){
		(FrmRect + drawCnt)->left   = apos.x + drawCnt - WindowRect.left;
		(FrmRect + drawCnt)->right  = (FrmRect + drawCnt)->left + FRAME_CNT + 1;
		(FrmRect + drawCnt)->top    = TreeViewRect.top - WindowRect.top;
		(FrmRect + drawCnt)->bottom = EditViewRect.bottom - WindowRect.top;
//#ifndef _WIN32_WCE
		DrawFocusRect(hdc, (LPRECT)(FrmRect + drawCnt));
//#endif
	}
#ifdef _WIN32_WCE
	ReleaseDC(hSplit, hdc);
#else
	ReleaseDC(hWnd, hdc);
#endif
	return 0;
}


/******************************************************************************

	FrameDrawHR

	Et[̕`

******************************************************************************/

int FrameDrawHR(HWND hWnd, int x, int y)
{
	RECT WindowRect, ListViewRect, ToolbarRect, StatusRect;
	POINT apos;
	HDC hdc;
	int drawCnt;
	int top, bottom;

	apos.x = x;
	apos.y = y;
#ifdef _WIN32_WCE_PPC
	apos.y = y - 26;
#endif
#ifdef _CENET
	apos.y = y - 24;
#endif
	GetWindowRect(hWnd, (LPRECT)&WindowRect);
	GetWindowRect(GetDlgItem(hWnd, IDC_LISTVIEW), (LPRECT)&ListViewRect);
	GetWindowRect(GetDlgItem(hWnd, IDC_TB), &ToolbarRect);
	GetWindowRect(GetDlgItem(hWnd, IDC_STATUS), &StatusRect);

	top    = WindowRect.top + NOMOVESIZE + 
		GetSystemMetrics(SM_CYEDGE) + GetSystemMetrics(SM_CYCAPTION) + GetSystemMetrics(SM_CYMENU) + 
		GetSystemMetrics(SM_CYMENU) + GetSystemMetrics(SM_CYBORDER) + 
#ifdef _WIN32_WCE
	#ifdef _WIN32_WCE_PPC
		(-26);
	#else
		MenuBar_GetHeight(hWnd);
	#endif
#else
		(ToolbarRect.bottom - ToolbarRect.top);
#endif

	bottom = WindowRect.bottom - (NOMOVESIZE + (FRAME_CNT * 2)) - GetSystemMetrics(SM_CYEDGE) - 
#ifdef _WIN32_WCE_PPC
		(26 + 8) - 
#endif
		(StatusRect.bottom - StatusRect.top);

	//t[̈ړ
	if(apos.y <= top){
		apos.y = top;
	}else if(apos.y >= bottom){
		apos.y = bottom;
	}

	//ÖʒuƔr
	if(apos.y == FrmRect[0].top){
		return 1;
	}

#ifdef _WIN32_WCE
	SetWindowPos (hSplit, HWND_TOP, 
		ListViewRect.left - WindowRect.left,
		apos.y - FRAME_CNT/2,
		ListViewRect.right - ListViewRect.left,
		FRAME_CNT,
		SWP_SHOWWINDOW);

	hdc = GetWindowDC(hSplit);
#else
	hdc = GetWindowDC(hWnd);
#endif

	//O`敪
//#ifndef _WIN32_WCE
	for(drawCnt = 0;drawCnt < FRAME_CNT;drawCnt++){
		DrawFocusRect(hdc, (LPRECT)&FrmRect[drawCnt]);
	}
//#endif

	//t[̕`
	for(drawCnt = 0;drawCnt < FRAME_CNT;drawCnt++){
		(FrmRect + drawCnt)->left   = ListViewRect.left - WindowRect.left;
		(FrmRect + drawCnt)->right  = ListViewRect.right - WindowRect.left;
		(FrmRect + drawCnt)->top    = apos.y + drawCnt - WindowRect.top;
		(FrmRect + drawCnt)->bottom = (FrmRect + drawCnt)->top + FRAME_CNT + 1;
//#ifndef _WIN32_WCE
		DrawFocusRect(hdc, (LPRECT)(FrmRect + drawCnt));
//#endif
	}
#ifdef _WIN32_WCE
	ReleaseDC(hSplit, hdc);
#else
	ReleaseDC(hWnd, hdc);
#endif
	return 0;
}


/******************************************************************************

	FrameDrawHL

	t[̕`

******************************************************************************/

int FrameDrawHL(HWND hWnd, int x, int y)
{
	RECT WindowRect, TreeViewRect, ToolbarRect, StatusRect;
	POINT apos;
	HDC hdc;
	int drawCnt;
	int top, bottom;

	apos.x = x;
	apos.y = y;
#ifdef _WIN32_WCE_PPC
	apos.y = y - 26;
#endif
#ifdef _CENET
	apos.y = y - 24;
#endif
	GetWindowRect(hWnd, (LPRECT)&WindowRect);
	GetWindowRect(GetDlgItem(hWnd, IDC_TREEVIEW), (LPRECT)&TreeViewRect);
	GetWindowRect(GetDlgItem(hWnd, IDC_TB), &ToolbarRect);
	GetWindowRect(GetDlgItem(hWnd, IDC_STATUS), &StatusRect);

	top    = WindowRect.top + NOMOVESIZE + 
		GetSystemMetrics(SM_CYEDGE) + GetSystemMetrics(SM_CYCAPTION) + GetSystemMetrics(SM_CYMENU) + 
		GetSystemMetrics(SM_CYMENU) + GetSystemMetrics(SM_CYBORDER) + 
#ifdef _WIN32_WCE
	#ifdef _WIN32_WCE_PPC
		0;
	#else
		MenuBar_GetHeight(hWnd);
	#endif
#else
		(ToolbarRect.bottom - ToolbarRect.top);
#endif

	bottom = WindowRect.bottom - (NOMOVESIZE + (FRAME_CNT * 2)) - GetSystemMetrics(SM_CYEDGE) - 
#ifdef _WIN32_WCE_PPC
		26 - 
#endif
		(StatusRect.bottom - StatusRect.top);

	//t[̈ړ
	if(apos.y <= top){
		apos.y = top;

	}else if(apos.y >= bottom){
		apos.y = bottom;
	}

	//ÖʒuƔr
	if(apos.y == FrmRect[0].top){
		return 1;
	}

#ifdef _WIN32_WCE
	SetWindowPos (hSplit, HWND_TOP, 
		TreeViewRect.left - WindowRect.left,
		apos.y - FRAME_CNT/2,
		TreeViewRect.right - WindowRect.left,
		FRAME_CNT,
		SWP_SHOWWINDOW);

	hdc = GetWindowDC(hSplit);
#else
	hdc = GetWindowDC(hWnd);
#endif

	//O`敪
//#ifndef _WIN32_WCE
	for(drawCnt = 0;drawCnt < FRAME_CNT;drawCnt++){
		DrawFocusRect(hdc, (LPRECT)&FrmRect[drawCnt]);
	}
//#endif

	//t[̕`
	for(drawCnt = 0;drawCnt < FRAME_CNT;drawCnt++){
		(FrmRect + drawCnt)->left   = TreeViewRect.left - WindowRect.left;
		(FrmRect + drawCnt)->right  = TreeViewRect.right - WindowRect.left;
		(FrmRect + drawCnt)->top    = apos.y + drawCnt - WindowRect.top;
		(FrmRect + drawCnt)->bottom = (FrmRect + drawCnt)->top + FRAME_CNT + 1;
//#ifndef _WIN32_WCE
		DrawFocusRect(hdc, (LPRECT)(FrmRect + drawCnt));
//#endif
	}
#ifdef _WIN32_WCE
	ReleaseDC(hSplit, hdc);
#else
	ReleaseDC(hWnd, hdc);
#endif
	return 0;
}


/******************************************************************************

	FrameDrawEnd

	t[̕`IAt[̍ŏIʒuԂ

******************************************************************************/

int FrameDrawEnd(HWND hWnd)
{
//#ifndef _WIN32_WCE
	HDC hdc;
	int drawCnt;
//#endif
	int x,y;

	if(FrmRect[0].left == 0 &&
		FrmRect[0].right == 0 &&
		FrmRect[0].top == 0 &&
		FrmRect[0].bottom == 0){

		FrameFree();
		return -1;
	}

#ifdef _WIN32_WCE
	ShowWindow (hSplit, SW_HIDE);
	hdc = GetWindowDC(hSplit);
#else
	//O`敪
	hdc = GetWindowDC(hWnd);
#endif
	for(drawCnt = 0;drawCnt < FRAME_CNT;drawCnt++){
		DrawFocusRect(hdc, (LPRECT)&FrmRect[drawCnt]);
	}
#ifdef _WIN32_WCE
	ReleaseDC(hSplit, hdc);
#else
	ReleaseDC(hWnd, hdc);
#endif

	//Eʒu̎擾
	x = FrmRect[0].left - GetSystemMetrics(SM_CXEDGE);
	y = FrmRect[0].top  - GetSystemMetrics(SM_CYEDGE) - GetSystemMetrics(SM_CYCAPTION);

#ifdef _WIN32_WCE
	y += GetSystemMetrics(SM_CYMENU) * 2;
#endif
#ifdef _WIN32_WCE_PPC
	y += 26;
#endif

	FrameFree();
	return MAKELONG (x,y);
}

/******************************************************************************

	WinMessageDone

	EChEbZ[W

******************************************************************************/

void WinMessageDone ()
{
	MSG msg;
	// EChEbZ[W
	while (PeekMessage (&msg, NULL, 0, 0, PM_NOREMOVE)) {
		// EChEbZ[W
        if (GetMessage (&msg, NULL, 0, 0)) {
			TranslateMessage(&msg);
			DispatchMessage (&msg);
        }
		else
			break;
	}
}
/* End of source */
