/**************************************************************************

	nPOP

	ListView.c

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

	nPOP-Q
	(C) Copyright 1999-2002 By Qta Sakamoto. All right reserved.

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include "General.h"


/**************************************************************************
	define
**************************************************************************/

#define ICONCOUNT			9


/**************************************************************************
	Global Variables
**************************************************************************/

//OQ
extern HINSTANCE hInst;
extern int SelBox;

extern int LvDefSelectPos;
extern int LvAutoSort;
extern int LvSortItem;
extern int LvThreadView;
extern int LvStyle;
extern int LvStyleEx;

extern int LvColSize[];

extern int TreeSaveNo;	//ۑ̃AJEgԍ(nPOP-Q)
extern int TreeSendNo;	//M̃AJEgԍ(nPOP-Q)
extern TCHAR* GetMailadr (TCHAR* str);	//(nPOP-Q)
extern struct TPMAILBOX *MailBox;	// (nPOP-Q)


/**************************************************************************
	Local Function Prototypes
**************************************************************************/

static int ImageListIconAdd(HIMAGELIST IconList, int Index);
static void ListView_GetDispItem(LV_ITEM *hLVItem);
static int GetIconSortStatus(struct TPMAILITEM *tpMailItem);


/******************************************************************************

	ImageListIconAdd

	C[WXgɃACRǉ

******************************************************************************/

static int ImageListIconAdd(HIMAGELIST IconList, int Index)
{
	HICON hIcon = NULL;
	int ret;

	hIcon = (HICON)LoadImage(hInst, MAKEINTRESOURCE(Index), IMAGE_ICON,
		SICONSIZE, SICONSIZE, 0);

	//C[WXgɃACRǉ
	ret = ImageList_AddIcon(IconList, hIcon);

	DestroyIcon(hIcon);
	return ret;
}


/******************************************************************************

	ListView_SetColumn

	Xgr[ɃJǉ

******************************************************************************/

void ListView_AddColumn(HWND hListView, int fmt, int cx, TCHAR *buf, int iSubItem)
{
	LV_COLUMN lvc;

	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;

	lvc.fmt = fmt;
	lvc.cx = cx;
	lvc.pszText = buf;
	lvc.iSubItem = iSubItem;
	ListView_InsertColumn(hListView, iSubItem, &lvc);
}


/******************************************************************************

	CreateListView

	Xgr[̍쐬Ə

******************************************************************************/

HWND CreateListView(HWND hWnd, int Top, int bottom)
{
	HIMAGELIST IconList;
	HIMAGELIST TmpIconList;
	HICON TmpIcon;
	RECT rcClient;
	HWND hListView;

	GetClientRect(hWnd, &rcClient);

#ifdef _WIN32_WCE
#define WS_EX_STYLE		0
#else
#define WS_EX_STYLE		WS_EX_NOPARENTNOTIFY | WS_EX_CLIENTEDGE
#endif
	hListView = CreateWindowEx(WS_EX_STYLE, WC_LISTVIEW, TEXT(""),
#ifdef _WIN32_WCE_LAGENDA
		WS_BORDER | WS_VISIBLE | WS_CHILD | WS_TABSTOP | LVS_EDITLABELS | LvStyle,
#else
		WS_BORDER | WS_VISIBLE | WS_CHILD | WS_TABSTOP | LvStyle,
#endif
		0, Top,
		rcClient.right, rcClient.bottom - Top - bottom, hWnd,
		(HMENU)IDC_LISTVIEW, hInst, NULL);
	if(hListView == NULL){
		return NULL;
	}

	//sI (nPOP-Q)
	//gX^C
//#ifdef _WIN32_WCE_PPC
//	ListView_SetExtendedListViewStyle(hListView, LvStyleEx | LVS_EX_ONECLICKACTIVATE);
//#else
	ListView_SetExtendedListViewStyle(hListView, LvStyleEx);
//#endif

	//wb_̐ݒ
	ListView_AddColumn(hListView, LVCFMT_LEFT, *(LvColSize + 0), STR_LIST_LVHEAD_SUBJECT, 0);
	ListView_AddColumn(hListView, LVCFMT_LEFT, *(LvColSize + 1), STR_LIST_LVHEAD_FROM, 1);
	ListView_AddColumn(hListView, LVCFMT_LEFT, *(LvColSize + 2), STR_LIST_LVHEAD_DATE, 2);
	ListView_AddColumn(hListView, LVCFMT_RIGHT, *(LvColSize + 3), STR_LIST_LVHEAD_SIZE, 3);

	//C[WXg̐ݒ
	IconList = ImageList_Create(SICONSIZE, SICONSIZE, ILC_COLOR | ILC_MASK, ICONCOUNT, ICONCOUNT);
	ImageListIconAdd(IconList, IDI_ICON_NON);
	ImageListIconAdd(IconList, IDI_ICON_MAIN);
	ImageListIconAdd(IconList, IDI_ICON_READ);
	ImageListIconAdd(IconList, IDI_ICON_DOWN);
	ImageListIconAdd(IconList, IDI_ICON_DEL);
	ImageListIconAdd(IconList, IDI_ICON_SENDMAIL);
	ImageListIconAdd(IconList, IDI_ICON_SEND);

	//MG[̃[쐬 (Mς݃[ƍ폜}[N̍)
	TmpIconList = ImageList_Merge(IconList, ICON_SENDMAIL, IconList, ICON_DEL, 0, 0);
	TmpIcon = ImageList_GetIcon(TmpIconList, 0, ILD_NORMAL);
	ImageList_AddIcon(IconList, TmpIcon);
	DestroyIcon(TmpIcon);
	ImageList_Destroy((void *)TmpIconList);

	//I[o[C
	ImageListIconAdd(IconList, IDI_ICON_NEW);
	ImageList_SetOverlayImage(IconList, ICON_NEW, 1);

	ListView_SetImageList(hListView, IconList, LVSIL_SMALL);

	IconList = ImageList_Create(SICONSIZE, SICONSIZE, ILC_COLOR | ILC_MASK, 1, 1);
	//Ytt@CpXe[^XACR
	ImageListIconAdd(IconList, IDI_ICON_CLIP);
	ListView_SetImageList(hListView, IconList, LVSIL_STATE);

	return hListView;
}


/******************************************************************************

	ListView_SetRedraw

	Xgr[̕`؂ւ

******************************************************************************/

void ListView_SetRedraw(HWND hListView, BOOL DrawFlag)
{
	switch(DrawFlag)
	{
	case FALSE:
		//`悵Ȃ
		SendMessage(hListView, WM_SETREDRAW, (WPARAM)FALSE, 0);
		break;

	case TRUE:
		//`悷
		SendMessage(hListView, WM_SETREDRAW, (WPARAM)TRUE, 0);
		UpdateWindow(hListView);
		break;
	}
}


/******************************************************************************

	ListView_InsertItemEx

	Xgr[ɃACeǉ

******************************************************************************/

int ListView_InsertItemEx(HWND hListView, TCHAR *buf, int len, int Img, long lp, int iItem)
{
	LV_ITEM lvi;

	lvi.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM;
	lvi.iItem = iItem;
	lvi.iSubItem = 0;
	lvi.pszText = buf;
	lvi.cchTextMax = len;
	lvi.iImage = Img;
	lvi.lParam = lp;

	// Xgr[ɃACeǉ
	return ListView_InsertItem(hListView, &lvi);
}


/******************************************************************************

	ListView_MoveItem

	Xgr[̃ACeړ

******************************************************************************/

void ListView_MoveItem(HWND hListView, int SelectItem, int Move, int ColCnt)
{
	TCHAR buf[10][BUF_SIZE];
	int i = 0;

	for(i = 0; i < ColCnt; i++){
		*(*(buf + i)) = TEXT('\0');
		ListView_GetItemText(hListView, SelectItem, i, *(buf + i), BUF_SIZE - 1);
	}
	ListView_DeleteItem(hListView, SelectItem);

	SelectItem = SelectItem + Move;

	ListView_InsertItemEx(hListView, *buf, BUF_SIZE, 0, 0, SelectItem);
	for(i = 1; i < ColCnt; i++){
		ListView_SetItemText(hListView, SelectItem, i, *(buf + i));
	}
	ListView_SetItemState(hListView, SelectItem,
		LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);
	ListView_EnsureVisible(hListView, SelectItem, TRUE);
}


/******************************************************************************

	ListView_GetSelStringList

	IACẽ^CgXg쐬

******************************************************************************/

TCHAR *ListView_GetSelStringList(HWND hListView)
{
	TCHAR buf[BUF_SIZE];
	TCHAR *StrAddr, *p;
	int SelectItem;
	int len;

	SelectItem = -1;
	len = 0;
	while((SelectItem = ListView_GetNextItem(hListView, SelectItem, LVNI_SELECTED)) != -1){
		*buf = TEXT('\0');
		ListView_GetItemText(hListView, SelectItem, 0, buf, BUF_SIZE - 1);
		len += lstrlen(buf) + 2;
	}

	p = StrAddr = (TCHAR *)LocalAlloc(LPTR, sizeof(TCHAR) * (len + 1));
	if(StrAddr == NULL){
		return NULL;
	}

	SelectItem = -1;
	while((SelectItem = ListView_GetNextItem(hListView, SelectItem, LVNI_SELECTED)) != -1){
		if(p != StrAddr){
			*(p++) = TEXT(',');
			*(p++) = TEXT(' ');
		}
		ListView_GetItemText(hListView, SelectItem, 0, p, BUF_SIZE - 1);
		p += lstrlen(p);
	}
	*p = TEXT('\0');
	return StrAddr;
}


/******************************************************************************

	ListView_GetlParam

	ACeLPARAM擾

******************************************************************************/

long ListView_GetlParam(HWND hListView, int i)
{
	LV_ITEM lvi;

	lvi.mask = LVIF_PARAM;
	lvi.iItem = i;
	lvi.iSubItem = 0;
	lvi.lParam = 0;
	ListView_GetItem(hListView, &lvi);
	return lvi.lParam;
}


/******************************************************************************

	ListView_GetMemToItem

	[ACe烊Xgr[̃CfbNX擾

******************************************************************************/

int ListView_GetMemToItem(HWND hListView, struct TPMAILITEM *tpMemMailItem)
{
	struct TPMAILITEM *tpMailItem;
	int i, ItemCnt;

	ItemCnt = ListView_GetItemCount(hListView);
	for(i = 0; i < ItemCnt; i++){
		tpMailItem = (struct TPMAILITEM *)ListView_GetlParam(hListView, i);
		if(tpMailItem == NULL){
			continue;
		}
		if(tpMailItem == tpMemMailItem){
			return i;
		}
	}
	return -1;
}


/******************************************************************************

	ListView_GetNextDeleteItem

	폜}[ÑACẽCfbNX擾

******************************************************************************/

int ListView_GetNextDeleteItem(HWND hListView, int Index)
{
	struct TPMAILITEM *tpMailItem;
	int i, ItemCnt;

	ItemCnt = ListView_GetItemCount(hListView);
	for(i = Index + 1; i < ItemCnt; i++){
		tpMailItem = (struct TPMAILITEM *)ListView_GetlParam(hListView, i);
		if(tpMailItem == NULL){
			continue;
		}
		if(tpMailItem->Status == ICON_DEL){
			return i;
		}
	}
	return -1;
}


/******************************************************************************

	ListView_GetNextMailItem

	wCfbNX̖{[ACẽCfbNX擾

******************************************************************************/

int ListView_GetNextMailItem(HWND hListView, int Index)
{
	struct TPMAILITEM *tpMailItem;
	int i, ItemCnt;

	ItemCnt = ListView_GetItemCount(hListView);
	for(i = Index + 1; i < ItemCnt; i++){
		tpMailItem = (struct TPMAILITEM *)ListView_GetlParam(hListView, i);
		if(tpMailItem == NULL || tpMailItem->Body == NULL){
			continue;
		}
		return i;
	}
	return -1;
}


/******************************************************************************

	ListView_GetPrevMailItem

	wCfbNXO̖{[ACẽCfbNX擾

******************************************************************************/

int ListView_GetPrevMailItem(HWND hListView, int Index)
{
	struct TPMAILITEM *tpMailItem;
	int i;

	if(Index == -1){
		Index = ListView_GetItemCount(hListView);
	}
	for(i = Index - 1; i >= 0; i--){
		tpMailItem = (struct TPMAILITEM *)ListView_GetlParam(hListView, i);
		if(tpMailItem == NULL || tpMailItem->Body == NULL){
			continue;
		}
		return i;
	}
	return -1;
}


/******************************************************************************

	ListView_GetNextNoReadItem

	J̃[ACẽCfbNX擾

******************************************************************************/

int ListView_GetNextNoReadItem(HWND hListView, int Index, int endindex)
{
	struct TPMAILITEM *tpMailItem;
	int i, ItemCnt;

	ItemCnt = ListView_GetItemCount(hListView);
	for(i = ((Index <= -1) ? 0 : Index); i < endindex; i++){
		tpMailItem = (struct TPMAILITEM *)ListView_GetlParam(hListView, i);
		if(tpMailItem == NULL || tpMailItem->Body == NULL){
			continue;
		}
		if(tpMailItem->MailStatus == ICON_MAIL){
			return i;
		}
	}
	return -1;
}


/******************************************************************************

	ListView_GetNewItem

	ṼCfbNX擾

******************************************************************************/

int ListView_GetNewItem(HWND hListView, struct TPMAILBOX *tpMailBox)
{
	struct TPMAILITEM *tpMailItem;
	int i;

	for(i = 0; i < tpMailBox->MailItemCnt; i++){
		tpMailItem = *(tpMailBox->tpMailItem + i);
		if(tpMailItem == NULL){
			continue;
		}
		if(tpMailItem->New == TRUE){
			return ListView_GetMemToItem(hListView, tpMailItem);
		}
	}
	return -1;
}


/******************************************************************************

	ListView_MaskToAddr (nPOP-Q)

	[ To AhX ƎwAJEgr

******************************************************************************/

int ListView_MaskToAddr (struct TPMAILITEM *tpMailItem, int SelExt)
{
	TCHAR* To = TEXT("");
	TCHAR* Ma;

	if (tpMailItem->To) To = GetMailadr(tpMailItem->To);

	Ma = (((MailBox + SelExt)->MailAddress == NULL) ? TEXT("") : (MailBox + SelExt)->MailAddress);

	if (TStrCmpI(Ma,To) != 0) {
		Ma = (((MailBox + SelExt)->Name == NULL) ? TEXT("") : (MailBox + SelExt)->Name);
		if (TStrCmpI(Ma,To) != 0) {
			Ma = (((MailBox + SelExt)->UserName == NULL) ? TEXT("") : (MailBox + SelExt)->UserName);
			if (TStrCmpI(Ma,To) != 0) return FALSE;	//sv
		}
	}
	return TRUE;	//v
}


/******************************************************************************

	ListView_MaskFromAddr (nPOP-Q)

	[ From AhX ƎwAJEgr

******************************************************************************/

int ListView_MaskFromAddr (struct TPMAILITEM *tpMailItem, int SelExt)
{
	TCHAR* From = TEXT("");
	TCHAR* Ma;

	if (tpMailItem->From) From = GetMailadr(tpMailItem->From);
	
	Ma = (((MailBox + SelExt)->MailAddress == NULL) ? TEXT("") : (MailBox + SelExt)->MailAddress);
	
	if (TStrCmpI(Ma,From) != 0) {
		Ma = (((MailBox + SelExt)->Name == NULL) ? TEXT("") : (MailBox + SelExt)->Name);
		if (TStrCmpI(Ma,From) != 0) {
			Ma = (((MailBox + SelExt)->UserName == NULL) ? TEXT("") : (MailBox + SelExt)->UserName);
			if (TStrCmpI(Ma,From) != 0) return FALSE;	//sv
		}
	}
	return TRUE;	//v
}

extern int MailBoxCnt;

int ListView_MaskToAddrOther (struct TPMAILITEM *tpMailItem)
{
	int rc;
	int SelExt;
	for (SelExt = MAILBOX_USER; SelExt < MailBoxCnt; SelExt++) {
		rc = ListView_MaskToAddr (tpMailItem, SelExt);
		if (rc) return rc;
	}
	return FALSE;
}

int ListView_MaskFromAddrOther (struct TPMAILITEM *tpMailItem)
{
	int rc;
	int SelExt;
	for (SelExt = MAILBOX_USER; SelExt < MailBoxCnt; SelExt++) {
		rc = ListView_MaskFromAddr (tpMailItem, SelExt);
		if (rc) return rc;
	}
	return FALSE;
}


/******************************************************************************

	ListView_ShowItem

	Xgr[ɃACe\

******************************************************************************/

BOOL ListView_ShowItem(HWND hListView, struct TPMAILBOX *tpMailBox)
{
	struct TPMAILITEM *tpMailItem;
	LV_ITEM lvi;
	int i, j;
	int index = -1;

	ListView_SetRedraw(hListView, FALSE);
	//ׂẴACe폜
	ListView_DeleteAllItems(hListView);

	ListView_SetItemCount(hListView, tpMailBox->MailItemCnt);

	//ACe̒ǉ
	lvi.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_PARAM | LVIF_STATE;
	lvi.iSubItem = 0;
	lvi.stateMask = LVIS_OVERLAYMASK | LVIS_STATEIMAGEMASK | LVIS_CUT;
	lvi.pszText = LPSTR_TEXTCALLBACK;
	lvi.cchTextMax = 0;
	lvi.iImage = I_IMAGECALLBACK;

	for(i = 0, j = -1; i < tpMailBox->MailItemCnt; i++){
		if((tpMailItem = (*(tpMailBox->tpMailItem + i))) == NULL){
			continue;
		}
		// AJEgʕ\ (nPOP-Q)
		if(SelBox == MAILBOX_SAVE && TreeSaveNo != -1){
			if (TreeSaveNo + MAILBOX_USER != MailBoxCnt) {
				int SelExt = TreeSaveNo + MAILBOX_USER;
				int rc = ListView_MaskToAddr (tpMailItem, SelExt);
				if (!rc) continue;
			}
			else {
				int rc = ListView_MaskToAddrOther (tpMailItem);
				if (rc) continue;
			}
		}
		if(SelBox == MAILBOX_SEND && TreeSendNo != -1){
			if (TreeSendNo + MAILBOX_USER != MailBoxCnt) {
				int SelExt = TreeSendNo + MAILBOX_USER;
				int rc = ListView_MaskFromAddr (tpMailItem, SelExt);
				if (!rc) continue;
			}
			else {
				int rc = ListView_MaskFromAddrOther (tpMailItem);
				if (rc) continue;
			}
		}
		// ----
		lvi.state = (tpMailItem->New == TRUE) ? INDEXTOOVERLAYMASK(1) : 0;
		lvi.state |= ((tpMailItem->Multipart == TRUE) ? INDEXTOSTATEIMAGEMASK(1) : 0);
		if(tpMailItem->Download == FALSE && tpMailItem->Status != ICON_DOWN &&
			tpMailItem->Status != ICON_DEL && MAILBOX_SEND != SelBox){
			lvi.state |= LVIS_CUT;
		}
		lvi.iItem = j + 1;
		lvi.lParam = (LPARAM)tpMailItem;

		// Xgr[ɃACeǉ
		j = ListView_InsertItem(hListView, &lvi);
		if(j == -1){
			ListView_SetRedraw(hListView, TRUE);
			return FALSE;
		}
	}

	if(LvThreadView == 1){
		//Xbh\
		Item_SetThread(tpMailBox);
		ListView_SortItems(hListView, CompareFunc, SORT_THREAD + 1);
	}else if((SelBox == MAILBOX_SAVE && LvAutoSort == 1) || LvAutoSort == 2){
		//\[g
		ListView_SortItems(hListView, CompareFunc, LvSortItem);
	}
	ListView_SetRedraw(hListView, FALSE);

	//ACeIԂɂ
	if((j = ListView_GetItemCount(hListView)) > 0){
		ListView_EnsureVisible(hListView, j - 1, TRUE);
		//Jʒu̎擾
		i = ListView_GetNextNoReadItem(hListView, -1, ListView_GetItemCount(hListView));
		if(SelBox < MAILBOX_USER || i == -1){
			//Ō̃[I
			index = (LvDefSelectPos == 0) ? 0 : j - 1;
			ListView_SetItemState(hListView, index,
				LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);
		}else{
			//J[I
			ListView_SetItemState(hListView, i,
				LVIS_FOCUSED | LVIS_SELECTED, LVIS_FOCUSED | LVIS_SELECTED);
			index = (i <= 0) ? 0 : (i - 1);
			ListView_EnsureVisible(hListView, index, TRUE);
		}
	}
	ListView_SetRedraw(hListView, TRUE);
	if(index != -1){
		ListView_EnsureVisible(hListView, index, TRUE);
	}
	return TRUE;
}


/******************************************************************************

	ListView_GetDispItem

	Xgr[ɕ\ACe̐ݒ

******************************************************************************/

static void ListView_GetDispItem(LV_ITEM *hLVItem)
{
	struct TPMAILITEM *tpMailItem = (struct TPMAILITEM *)hLVItem->lParam;
	TCHAR *p = NULL, *r;
	int i, j;

	if(tpMailItem == NULL){
		return;
	}

	//ACR
	if(hLVItem->mask & LVIF_IMAGE){
		hLVItem->iImage = tpMailItem->Status;
	}

	//eLXg
	if(hLVItem->mask & LVIF_TEXT){
		switch(hLVItem->iSubItem)
		{
		//
		case 0:
			p = (tpMailItem->Subject != NULL && *tpMailItem->Subject != TEXT('\0')) ?
				tpMailItem->Subject : STR_LIST_NOSUBJECT;

			if(LvThreadView == 1 && tpMailItem->Indent != 0){
				r = hLVItem->pszText;
				//Cfgǉ󔒂̐vZ
				j = ((tpMailItem->Indent * 4) > (hLVItem->cchTextMax - 1)) ?
					((hLVItem->cchTextMax - 1) / 4) : tpMailItem->Indent;
				j = (j - 1) * 4;
				//󔒂̒ǉ
				for(i = 1; i < j; i++){
					*(r++) = TEXT(' ');
				}
				//}̒ǉ
				r = TStrCpy(r, STR_LIST_THREADSTR);
				//̒ǉ
				TStrCpyN(r, p, BUF_SIZE - (r - hLVItem->pszText) - 1);
				return;
			}
			break;

		//ol (M̏ꍇ͎l)
		case 1:
			p = (MAILBOX_SEND == SelBox) ? tpMailItem->To : tpMailItem->From;
			break;

		//t
		case 2:
			p = tpMailItem->Date;
			break;

		//TCY
		case 3:
			p = tpMailItem->Size;
			break;

		default:
			return;
		}
		TStrCpyN(hLVItem->pszText, (p != NULL) ? p : TEXT("\0"), BUF_SIZE - 1);
	}
}


/******************************************************************************

	GetIconSortStatus

	\[gp̃Xe[^X̎擾

******************************************************************************/

static int GetIconSortStatus(struct TPMAILITEM *tpMailItem)
{
	switch(tpMailItem->Status)
	{
	case ICON_MAIL:		return (tpMailItem->Download == TRUE) ? 1 : 2;
	case ICON_READ:		return (tpMailItem->Download == TRUE) ? 3 : 4;
	case ICON_SENDMAIL:	return 5;
	case ICON_ERROR:	return 6;
	case ICON_DOWN:		return 7;
	case ICON_DEL:		return 8;
	case ICON_SEND:		return 9;
	case ICON_NON:		return 10;
	}
	return 0;
}


/******************************************************************************

	CompareFunc

	\[gtOɏ]ĕ̔rs

******************************************************************************/

int CALLBACK CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	TCHAR *wbuf1, *wbuf2;
	TCHAR tbuf1[BUF_SIZE], tbuf2[BUF_SIZE];
#ifdef UNICODE
	char tmp1[BUF_SIZE], tmp2[BUF_SIZE];
#endif
	int ret, sfg, ghed;
	int len1 = 0, len2 = 0;
	BOOL NumFlag = FALSE;

	sfg = (lParamSort < 0) ? 1 : 0;	//^~
	ghed = ABS(lParamSort) - 1;		//\[gswb_

	if(lParam1 == 0 || lParam2 == 0){
		return 0;
	}

	wbuf1 = TEXT("\0");
	wbuf2 = TEXT("\0");

	switch(ghed)
	{
	//
	case 0:
		if(((struct TPMAILITEM *)lParam1)->Subject != NULL)
			wbuf1 = ((struct TPMAILITEM *)lParam1)->Subject;
		if(((struct TPMAILITEM *)lParam2)->Subject != NULL)
			wbuf2 = ((struct TPMAILITEM *)lParam2)->Subject;
		break;

	//ol (M̏ꍇ͎l)
	case 1:
		if(MAILBOX_SEND == SelBox){
			if(((struct TPMAILITEM *)lParam1)->To != NULL)
				wbuf1 = ((struct TPMAILITEM *)lParam1)->To;
			if(((struct TPMAILITEM *)lParam2)->To != NULL)
				wbuf2 = ((struct TPMAILITEM *)lParam2)->To;
		}else{
			if(((struct TPMAILITEM *)lParam1)->From != NULL)
				wbuf1 = ((struct TPMAILITEM *)lParam1)->From;
			if(((struct TPMAILITEM *)lParam2)->From != NULL)
				wbuf2 = ((struct TPMAILITEM *)lParam2)->From;
		}
		break;

	//t
	case 2:
		if(((struct TPMAILITEM *)lParam1)->Date != NULL)
			wbuf1 = ((struct TPMAILITEM *)lParam1)->Date;
		if(((struct TPMAILITEM *)lParam2)->Date != NULL)
			wbuf2 = ((struct TPMAILITEM *)lParam2)->Date;
		if(MAILBOX_SEND == SelBox){
			char dbuf[BUF_SIZE];
#ifdef UNICODE
			TcharToChar(wbuf1, tmp1, BUF_SIZE);
			DateConv(tmp1, tmp2);
			SortDateConv(tmp2, dbuf);
			CharToTchar(dbuf, tbuf1, BUF_SIZE);

			TcharToChar(wbuf2, tmp1, BUF_SIZE);
			DateConv(tmp1, tmp2);
			SortDateConv(tmp2, dbuf);
			CharToTchar(dbuf, tbuf2, BUF_SIZE);
#else
			DateConv(wbuf1, dbuf);
			SortDateConv(dbuf, tbuf1);
			DateConv(wbuf2, dbuf);
			SortDateConv(dbuf, tbuf2);
#endif
		}else{
#ifdef UNICODE
			TcharToChar(wbuf1, tmp1, BUF_SIZE);
			SortDateConv(tmp1, tmp2);
			CharToTchar(tmp2, tbuf1, BUF_SIZE);

			TcharToChar(wbuf2, tmp1, BUF_SIZE);
			SortDateConv(tmp1, tmp2);
			CharToTchar(tmp2, tbuf2, BUF_SIZE);
#else
			SortDateConv(wbuf1, tbuf1);
			SortDateConv(wbuf2, tbuf2);
#endif
		}
		wbuf1 = tbuf1;
		wbuf2 = tbuf2;
		break;

	//TCY
	case 3:
		if(((struct TPMAILITEM *)lParam1)->Size != NULL)
			len1 = _ttoi(((struct TPMAILITEM *)lParam1)->Size);
		if(((struct TPMAILITEM *)lParam2)->Size != NULL)
			len2 = _ttoi(((struct TPMAILITEM *)lParam2)->Size);
		NumFlag = TRUE;
		break;

	//ԍ
	case SORT_NO:
		len1 = ((struct TPMAILITEM *)lParam1)->No;
		len2 = ((struct TPMAILITEM *)lParam2)->No;
		NumFlag = TRUE;
		break;

	//ACR
	case SORT_IOCN:
		len1 = GetIconSortStatus((struct TPMAILITEM *)lParam1);
		len2 = GetIconSortStatus((struct TPMAILITEM *)lParam2);
		NumFlag = TRUE;
		break;

	//Xbh
	case SORT_THREAD:
		len1 = ((struct TPMAILITEM *)lParam1)->PrevNo;
		len2 = ((struct TPMAILITEM *)lParam2)->PrevNo;
		NumFlag = TRUE;
		break;
	}

	ret = (NumFlag == FALSE) ? TStrCmpI(wbuf1, wbuf2) : (len1 - len2);
	return (((ret < 0 && sfg == 1) || (ret > 0 && sfg == 0)) ? 1 : -1);
}


/******************************************************************************

	ListView_NotifyProc

	Xgr[Cxg

******************************************************************************/

LRESULT ListView_NotifyProc(HWND hWnd, LPARAM lParam)
{
	LV_DISPINFO *plv = (LV_DISPINFO *)lParam;
	NMHDR *CForm = (NMHDR *)lParam;

	switch(plv->hdr.code)
	{
	case LVN_GETDISPINFO:		//\ACe̗v
		ListView_GetDispItem(&(plv->item));
		return TRUE;

#ifdef _WIN32_WCE_LAGENDA
	case LVN_BEGINLABELEDIT:
#endif
#ifdef _WIN32_WCE_PPC
	case LVN_ITEMACTIVATE:
#endif
	case LVN_ITEMCHANGED:		//ACȇIԂ̕ύX
		return SendMessage(hWnd, WM_LV_EVENT, plv->hdr.code, lParam);

#if defined(_WIN32_WCE_PPC) || defined(_WIN32_WCE_LAGENDA)
	case LVN_BEGINDRAG:
		//hbOőI͈͂̊g
		return LVBD_DRAGSELECT;
#endif
	}

	switch(CForm->code)
	{	// (nPOP-Q)
#ifndef _WIN32_WCE_PPC
	case NM_CLICK:				//NbN
#endif
	case NM_DBLCLK:				//_uNbN
	case NM_RCLICK:				//ENbN
		return SendMessage(hWnd, WM_LV_EVENT, CForm->code, lParam);
	}
//	{
//#ifndef _WIN32_WCE_PPC
//	case NM_DBLCLK:				//_uNbN
//#endif
//	case NM_CLICK:				//NbN
//	case NM_RCLICK:				//ENbN
//		return SendMessage(hWnd, WM_LV_EVENT, CForm->code, lParam);
//	}
	return FALSE;
}
/* End of source */
