/**************************************************************************

	nPOP

	MailBox.c

	Copyright (C) 1996-2002 by Tomoaki Nakashima. All rights reserved.
		http://www.nakka.com/
		nakka@nakka.com

	nPOP-Q
	(C) Copyright 1999-2002 By Qta Sakamoto. All right reserved.

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include "General.h"
#include "Options.h"	//(nPOP-Q)


/**************************************************************************
	Define
**************************************************************************/

#define IDC_CB				2000

#define POP_PORT			110
#define SMTP_PORT			25


/**************************************************************************
	Global Variables
**************************************************************************/

#ifdef _WIN32_WCE_LAGENDA
extern HMENU hMainMenu;
#endif

extern int MailMenuPos;
extern HWND hMainToolBar;

extern struct TPMAILBOX *MailBox;
extern int MailBoxCnt;

extern struct TPMAILBOX *AddressBox;

extern int SelBox;
extern int LvSortFlag;
extern BOOL EndThreadSortFlag;
extern BOOL PPCFlag;

// (nPOP-Q)
extern HWND  g_hEditView;
extern HWND  g_hTreeView;
extern void EditView_RestNo ();


/******************************************************************************

	InitMailBox

	[{bNX̏

******************************************************************************/

BOOL InitMailBox(void)
{

	//[{bNX̃Xg̊m
	MailBoxCnt = 2;
	MailBox = (struct TPMAILBOX *)LocalAlloc(LPTR, sizeof(struct TPMAILBOX) * MailBoxCnt);
	if(MailBox == NULL){
		return FALSE;
	}
	//AhX̊m
	AddressBox = (struct TPMAILBOX *)LocalAlloc(LPTR, sizeof(struct TPMAILBOX));
	if(AddressBox == NULL){
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	FreeFilterInfo

	tB^̉

******************************************************************************/

void FreeFilterInfo(struct TPMAILBOX *tpMailBox)
{
	int i;

	//tB^̉
	for(i = 0; i < tpMailBox->FilterCnt; i++){
		if(*(tpMailBox->tpFilter + i) == NULL){
			continue;
		}
		NULLCHECK_FREE((*(tpMailBox->tpFilter + i))->Header1);
		NULLCHECK_FREE((*(tpMailBox->tpFilter + i))->Content1);

		NULLCHECK_FREE((*(tpMailBox->tpFilter + i))->Header2);
		NULLCHECK_FREE((*(tpMailBox->tpFilter + i))->Content2);

		LocalFree(*(tpMailBox->tpFilter + i));
	}
	NULLCHECK_FREE(tpMailBox->tpFilter);
	tpMailBox->tpFilter = NULL;
}


/******************************************************************************

	FreeMailBox

	[{bNX̉

******************************************************************************/

void FreeMailBox(struct TPMAILBOX *tpMailBox)
{
	if(tpMailBox == NULL){
		return;
	}
	//AJEg̉
	NULLCHECK_FREE(tpMailBox->Name);
	NULLCHECK_FREE(tpMailBox->Server);
	NULLCHECK_FREE(tpMailBox->User);
	NULLCHECK_FREE(tpMailBox->Pass);
	NULLCHECK_FREE(tpMailBox->TmpPass);
	NULLCHECK_FREE(tpMailBox->LastMessageId);
	NULLCHECK_FREE(tpMailBox->SmtpServer);
	NULLCHECK_FREE(tpMailBox->UserName);
	NULLCHECK_FREE(tpMailBox->MailAddress);
	NULLCHECK_FREE(tpMailBox->Signature);
	NULLCHECK_FREE(tpMailBox->ReplyTo);
	NULLCHECK_FREE(tpMailBox->BccAddr);
	NULLCHECK_FREE(tpMailBox->SmtpUser);
	NULLCHECK_FREE(tpMailBox->SmtpPass);
	NULLCHECK_FREE(tpMailBox->SmtpTmpPass);
	NULLCHECK_FREE(tpMailBox->RasEntry);

	//tB^̉
	FreeFilterInfo(tpMailBox);

	//[̉
	if(tpMailBox->tpMailItem != NULL){
		FreeMailItem(tpMailBox->tpMailItem, tpMailBox->MailItemCnt);
		LocalFree(tpMailBox->tpMailItem);
	}
	tpMailBox->tpMailItem = NULL;
	tpMailBox->AllocCnt = tpMailBox->MailItemCnt = 0;
}


/******************************************************************************

	ReadMailBox

	Œ胁[{bNX̓ǂݍ

******************************************************************************/

BOOL ReadMailBox(void)
{
	//ۑ
	(MailBox + MAILBOX_SAVE)->Name = AllocCopy(STR_SAVEBOX_NAME);
	if(ReadItemList(SAVEBOX_FILE, (MailBox + MAILBOX_SAVE)) == FALSE){
		return FALSE;
	}

	//M
	(MailBox + MAILBOX_SEND)->Name = AllocCopy(STR_SENDBOX_NAME);
	if(ReadItemList(SENDBOX_FILE, (MailBox + MAILBOX_SEND)) == FALSE){
		return FALSE;
	}

	//AhX
	if(ReadAddressBook(ADDRESS_FILE, AddressBox, 0) == 0){
		if(ReadItemList(ADDRESS_FILE_OLD, AddressBox) == FALSE){
			return FALSE;
		}
	}

	//(nPOP-Q)
	//ŒAhX
	if (g_Winpos.ADDRESS_FILE2[0])
		ReadAddressBook(g_Winpos.ADDRESS_FILE2, AddressBox, 1);

	return TRUE;
}


/******************************************************************************

	CreateMailBox

	[{bNX̒ǉ

******************************************************************************/

int CreateMailBox(HWND hWnd, BOOL ShowFlag)
{
	struct TPMAILBOX *TmpMailBox;
	int cnt, index;

	//[{bNX̃Xgɒǉ
	index = MailBoxCnt;
	cnt = MailBoxCnt + 1;

	TmpMailBox = (struct TPMAILBOX *)LocalAlloc(LPTR, sizeof(struct TPMAILBOX) * cnt);
	if(TmpMailBox == NULL){
		return -1;
	}
	tCopyMemory(TmpMailBox, MailBox, sizeof(struct TPMAILBOX) * MailBoxCnt);

	(TmpMailBox + index)->Port = POP_PORT;
	(TmpMailBox + index)->SmtpPort = SMTP_PORT;

	LocalFree(MailBox);
	MailBox = TmpMailBox;
	MailBoxCnt++;

	if(ShowFlag == TRUE){
		int i;

		//R{{bNXɃ[{bNXǉđI
		i = SendDlgItemMessage(hWnd, IDC_COMBO, CB_ADDSTRING, 0, (LPARAM)STR_MAILBOX_NONAME);
		if(i == CB_ERR){
			return -1;
		}
		SendDlgItemMessage(hWnd, IDC_COMBO, CB_SETCURSEL, i, 0);
		return i;
	}
	//̊mۂ̂
	return index;
}


/******************************************************************************

	DeleteMailBox

	[{bNX̍폜

******************************************************************************/

int DeleteMailBox(HWND hWnd, int DelIndex)
{
	struct TPMAILBOX *TmpMailBox;
	int cnt;
	int i, j;

	TreeView_ResetMailBox (g_hTreeView, TRUE);	// (nPOP-Q)

	//[{bNX̃Xg폜
	cnt = MailBoxCnt - 1;
	TmpMailBox = (struct TPMAILBOX *)LocalAlloc(LPTR, sizeof(struct TPMAILBOX) * cnt);
	if(TmpMailBox == NULL){
		return -1;
	}
	j = 0;
	for(i = 0; i < MailBoxCnt; i++){
		if(i == DelIndex){
			FreeMailBox(MailBox + i);
			continue;
		}
		tCopyMemory((TmpMailBox + j), (MailBox + i), sizeof(struct TPMAILBOX));
		j++;
	}
	LocalFree(MailBox);
	MailBox = TmpMailBox;
	MailBoxCnt = cnt;

	//R{{bNX폜āAÕ[{bNXI
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_DELETESTRING, DelIndex, 0);
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_SETCURSEL, DelIndex - 1, 0);
	
	TreeView_ResetMailBox (g_hTreeView, FALSE);	// (nPOP-Q)

	return DelIndex - 1;
}


/******************************************************************************

	MoveUpMailBox

	[{bNẌʒuɈړ

******************************************************************************/

void MoveUpMailBox(HWND hWnd)
{
	struct TPMAILBOX *TmpMailBox;
	int i;

	if(SelBox <= MAILBOX_USER || MailBoxCnt <= MAILBOX_USER + 1){
		return;
	}

	//̈ʒuړ
	TmpMailBox = (struct TPMAILBOX *)LocalAlloc(LPTR, sizeof(struct TPMAILBOX) * MailBoxCnt);
	if(TmpMailBox == NULL){
		return;
	}

	for(i = 0; i < MailBoxCnt; i++){
		if(SelBox == i + 1){
			tCopyMemory((TmpMailBox + i), (MailBox + i + 1), sizeof(struct TPMAILBOX));
			tCopyMemory((TmpMailBox + i + 1), (MailBox + i), sizeof(struct TPMAILBOX));
			i++;
		}else{
			tCopyMemory((TmpMailBox + i), (MailBox + i), sizeof(struct TPMAILBOX));
		}
	}
	LocalFree(MailBox);
	MailBox = TmpMailBox;

	//R{{bNXɕ\Ăʒuړ
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_DELETESTRING, SelBox, 0);
	SelBox--;
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_INSERTSTRING, SelBox,
		(LPARAM)(((MailBox + SelBox)->Name == NULL || *(MailBox + SelBox)->Name == TEXT('\0'))
		? STR_MAILBOX_NONAME : (MailBox + SelBox)->Name));
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_SETCURSEL, SelBox, 0);
}


/******************************************************************************

	MoveDownMailBox

	[{bNẌʒuɈړ

******************************************************************************/

void MoveDownMailBox(HWND hWnd)
{
	struct TPMAILBOX *TmpMailBox;
	int i;

	if(SelBox < MAILBOX_USER || SelBox >= MailBoxCnt - 1 || MailBoxCnt <= MAILBOX_USER + 1){
		return;
	}

	//̈ʒuړ
	TmpMailBox = (struct TPMAILBOX *)LocalAlloc(LPTR, sizeof(struct TPMAILBOX) * MailBoxCnt);
	if(TmpMailBox == NULL){
		return;
	}

	for(i = 0; i < MailBoxCnt; i++){
		if(SelBox == i){
			tCopyMemory((TmpMailBox + i), (MailBox + i + 1), sizeof(struct TPMAILBOX));
			tCopyMemory((TmpMailBox + i + 1), (MailBox + i), sizeof(struct TPMAILBOX));
			i++;
		}else{
			tCopyMemory((TmpMailBox + i), (MailBox + i), sizeof(struct TPMAILBOX));
		}
	}
	LocalFree(MailBox);
	MailBox = TmpMailBox;

	//R{{bNXɕ\Ăʒuړ
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_DELETESTRING, SelBox, 0);
	SelBox++;
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_INSERTSTRING, SelBox,
		(LPARAM)(((MailBox + SelBox)->Name == NULL || *(MailBox + SelBox)->Name == TEXT('\0'))
		? STR_MAILBOX_NONAME : (MailBox + SelBox)->Name));
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_SETCURSEL, SelBox, 0);
}


/******************************************************************************

	CheckNoReadMailBox

	[{bNXɖJ[݂邩ׂ

******************************************************************************/

BOOL CheckNoReadMailBox(int index, BOOL NewFlag)
{
	int i;

	for(i = (MailBox + index)->MailItemCnt - 1; i >= 0 ; i--){
		if(*((MailBox + index)->tpMailItem + i) == NULL){
			continue;
		}
		if((NewFlag == TRUE || (*((MailBox + index)->tpMailItem + i))->New == TRUE) &&
			(*((MailBox + index)->tpMailItem + i))->MailStatus == ICON_MAIL){
			return TRUE;
		}
	}
	return FALSE;
}


/******************************************************************************

	NextNoReadMailBox

	J[݂郁[{bNX̃CfbNX擾

******************************************************************************/

int NextNoReadMailBox(int index, int endindex)
{
	int j;

	if(index < MAILBOX_USER){
		return -1;
	}
	for(j = index; j < endindex; j++){
		if(CheckNoReadMailBox(j, TRUE) == TRUE){
			return j;
		}
	}
	return -1;
}


/******************************************************************************

	SetNoReadCntTitle

	ǃ[{bNX̐^Cgo[ɕ\

******************************************************************************/

void SetNoReadCntTitle(HWND hWnd)
{
	TCHAR wbuf[BUF_SIZE];
	int i;
	int NoReadMailBox = 0;

	for(i = MAILBOX_USER; i < MailBoxCnt; i++){
		if((MailBox + i)->NoRead == TRUE){
			NoReadMailBox++;
		}
	}

	//ǃAJEg^Cgo[ɐݒ
	if(NoReadMailBox == 0){
		SetWindowText(hWnd, WINDOW_TITLE);
	}else{
		wsprintf(wbuf, STR_TITLE_NOREADMAILBOX, WINDOW_TITLE, NoReadMailBox);
		SetWindowText(hWnd, wbuf);
	}
}


/******************************************************************************

	SelectMailBox

	[{bNX̑I

******************************************************************************/

void SelectMailBox(HWND hWnd, int Sel)
{
	HMENU hMenu;
	LV_COLUMN lvc;
	TCHAR *p;

	if(Sel == -1){
		return;
	}
	SelBox = Sel;

	//Tv݂̌̕\폜 (nPOP-Q)
	if (g_hEditView != NULL) {
		SendMessage(g_hEditView, WM_SETTEXT, 0, (LPARAM)TEXT(""));
		EditView_RestNo ();
	}

	p = ((MailBox + SelBox)->Name == NULL || *(MailBox + SelBox)->Name == TEXT('\0'))
		? STR_MAILBOX_NONAME : (MailBox + SelBox)->Name;
	(MailBox + SelBox)->NoRead = FALSE;
	//V "*" tĂꍇ̓R{{bNX̃Xgݒ肵
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_DELETESTRING, SelBox, 0);
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_INSERTSTRING, SelBox, (LPARAM)p);
	SendDlgItemMessage(hWnd, IDC_COMBO, CB_SETCURSEL, SelBox, 0);

	//j[̎擾
#ifdef _WIN32_WCE
#ifdef _WIN32_WCE_PPC
	hMenu = SHGetSubMenu(hMainToolBar, ID_MENUITEM_MAIL);
#elif defined(_WIN32_WCE_LAGENDA)
	hMenu = GetSubMenu(hMainMenu, MailMenuPos);
#else
	hMenu = GetSubMenu(CommandBar_GetMenu(GetDlgItem(hWnd, IDC_CB), 0), MailMenuPos);
#endif
#else
	hMenu = GetSubMenu(GetMenu(hWnd), MailMenuPos);
#endif

	//ԐMAMpɃ}[N ̍ڂ폜
	DeleteMenu(hMenu, ID_MENUITEM_REMESSEGE, MF_BYCOMMAND);
	DeleteMenu(hMenu, ID_MENUITEM_DOWNMARK, MF_BYCOMMAND);
	DeleteMenu(hMenu, ID_MENUITE_SAVECOPY, MF_BYCOMMAND);

	if(SelBox == MAILBOX_SEND){
		//M
#ifdef _WIN32_WCE
		InsertMenu(hMenu, 1, MF_BYPOSITION | MF_STRING,
			ID_MENUITEM_REMESSEGE,
			(PPCFlag == TRUE) ? STR_LIST_PPCMENU_SENDINFO : STR_LIST_MENU_SENDINFO);
		InsertMenu(hMenu, ID_MENUITEM_DELMARK, MF_STRING,
			ID_MENUITEM_DOWNMARK,
			(PPCFlag == TRUE) ? STR_LIST_PPCMENU_SENDMARK : STR_LIST_MENU_SENDMARK);
		InsertMenu(hMenu, ID_MENUITEM_DELETE, MF_STRING,
			ID_MENUITE_SAVECOPY,
			(PPCFlag == TRUE) ? STR_LIST_PPCMENU_CREATECOPY : STR_LIST_MENU_CREATECOPY);
#else
		InsertMenu(hMenu, 1, MF_BYPOSITION | MF_STRING,
			ID_MENUITEM_REMESSEGE, STR_LIST_MENU_SENDINFO);
		InsertMenu(hMenu, ID_MENUITEM_DELMARK, MF_STRING,
			ID_MENUITEM_DOWNMARK, STR_LIST_MENU_SENDMARK);
		InsertMenu(hMenu, ID_MENUITEM_DELETE, MF_STRING,
			ID_MENUITE_SAVECOPY, STR_LIST_MENU_CREATECOPY);
#endif
		lvc.pszText = STR_LIST_LVHEAD_TO;
	}else{
		//M
#ifdef _WIN32_WCE
		InsertMenu(hMenu, 1, MF_BYPOSITION | MF_STRING,
			ID_MENUITEM_REMESSEGE,
			(PPCFlag == TRUE) ? STR_LIST_PPCMENU_REPLY : STR_LIST_MENU_REPLY);
		InsertMenu(hMenu, ID_MENUITEM_DELMARK, MF_STRING,
			ID_MENUITEM_DOWNMARK,
			(PPCFlag == TRUE) ? STR_LIST_PPCMENU_RECVMARK : STR_LIST_MENU_RECVMARK);
		InsertMenu(hMenu, ID_MENUITEM_DELETE, MF_STRING,
			ID_MENUITE_SAVECOPY,
			(PPCFlag == TRUE) ? STR_LIST_PPCMENU_SAVEBOXCOPY : STR_LIST_MENU_SAVEBOXCOPY);
#else
		InsertMenu(hMenu, 1, MF_BYPOSITION | MF_STRING,
			ID_MENUITEM_REMESSEGE, STR_LIST_MENU_REPLY);
		InsertMenu(hMenu, ID_MENUITEM_DELMARK, MF_STRING,
			ID_MENUITEM_DOWNMARK, STR_LIST_MENU_RECVMARK);
		InsertMenu(hMenu, ID_MENUITEM_DELETE, MF_STRING,
			ID_MENUITE_SAVECOPY, STR_LIST_MENU_SAVEBOXCOPY);
#endif
		lvc.pszText = STR_LIST_LVHEAD_FROM;
	}

	//Xgr[wb_̐ݒ
	lvc.mask = LVCF_TEXT;
	lvc.cchTextMax = BUF_SIZE;
	ListView_SetColumn(GetDlgItem(hWnd, IDC_LISTVIEW), 1, &lvc);

	LvSortFlag = SORT_NO + 1;
	EndThreadSortFlag = FALSE;

	//Xgr[ɃACeݒ肷
	SwitchCursor(FALSE);
	ListView_ShowItem(GetDlgItem(hWnd, IDC_LISTVIEW), (MailBox + SelBox));
	SwitchCursor(TRUE);

	SetMailMenu(hWnd);
	SetItemCntStatusText(hWnd, NULL);
	SetNoReadCntTitle(hWnd);

	// c[̍ڂZbgȂ (nPOP-Q)
	if (g_hTreeView)
		TreeView_SelMailBox (g_hTreeView, SelBox, TRUE);
}


/******************************************************************************

	GetNameToMailBox

	[{bNX̖O烁[{bNX̃CfbNX擾

******************************************************************************/

int GetNameToMailBox(TCHAR *Name)
{
	int i;

	if(Name == NULL){
		return -1;
	}
	for(i = 0; i < MailBoxCnt; i++){
		if(TStrCmpI((MailBox + i)->Name, Name) == 0){
			return i;
		}
	}
	return -1;
}
/* End of source */
