/**************************************************************************

	nPOP-Q

	OptionQ.c

	(C) Copyright 1999-2002 By Qta Sakamoto. All right reserved.

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include "General.h"
#include "Options.h"	//(nPOP-Q)

#define IDC_EDIT_BODY		2003

extern HWND MainWnd;
extern HFONT hEditFont;
extern HWND hEditWnd;
extern HWND hViewWnd;
extern HWND g_hEditView;

extern TCHAR *FontName;
extern int FontSize;

#define FAMILYMAX   64
#define FPOINTMAX   32

typedef struct {
	int	  nNumFonts;
	TCHAR szFontFamily[LF_FACESIZE];
	LONG  aFontPoint[FPOINTMAX];
} FONTFAMSTRUCT;

FONTFAMSTRUCT ffs[FAMILYMAX];
INT sFamilyCnt = 0;

static HDC shDC = 0;


/******************************************************************************

	FontFamilyCallback

	tHg t@~񋓂R[obN֐

******************************************************************************/

int CALLBACK FontFamilyCallback (
CONST LOGFONT *lplf,
CONST TEXTMETRIC *lpntm,
DWORD nFontType, 
LPARAM lParam
) {
    // z̗vfől𒴂ꍇA񋓂~
    if (sFamilyCnt >= FAMILYMAX)
        return 0;

    // tHg̖̏Rs[
    lstrcpy (ffs[sFamilyCnt++].szFontFamily, lplf->lfFaceName);

    return 1;
}

/******************************************************************************

	DefTrueTypeSize
	
	TrueTypeFont̃TCYw

******************************************************************************/

void DefTrueTypeSize (FONTFAMSTRUCT* pffs)
{
	int aPoint[] = {6,8,9,10,11,12,14,16,18,20,22,24,0};
	int i;
	for (i = 0; aPoint[i] != 0; i++) {
		pffs->aFontPoint[pffs->nNumFonts] = aPoint[i];
		pffs->nNumFonts++;
	}
}

/******************************************************************************

	EnumSingleFontFamily
	
	tHg񋓂R[obN֐

******************************************************************************/

int CALLBACK EnumSingleFontFamily (
CONST LOGFONT *lplf, 
CONST TEXTMETRIC *lpntm, 
DWORD nFontType,
LPARAM lParam
) {
	FONTFAMSTRUCT* pffs;
	LONG lPoint;
	int i;

	pffs = (FONTFAMSTRUCT*)lParam;

    // z̗vfől𒴂ꍇA񋓂~
    if (pffs->nNumFonts >= FPOINTMAX)
        return 0;

	if (pffs->nNumFonts == 0 && (
#ifdef _WIN32_WCE
		lplf->lfClipPrecision == CLIP_STROKE_PRECIS
#else
		lplf->lfOutPrecision == OUT_TT_PRECIS ||
		lplf->lfOutPrecision == OUT_OUTLINE_PRECIS ||
		lplf->lfOutPrecision == OUT_STROKE_PRECIS
#endif
		))
		DefTrueTypeSize (pffs);

	lPoint = (lplf->lfHeight * 720) / GetDeviceCaps(shDC,LOGPIXELSY);
	//ľܓ
	pffs->aFontPoint[pffs->nNumFonts] = (lPoint / 10) + ((lPoint % 10 >= 5)?1:0);

	for (i = 0; i < pffs->nNumFonts; i++) {
		if (pffs->aFontPoint[i] == pffs->aFontPoint[pffs->nNumFonts])
			return 1;
	}

	// t@~̃tHg̃JE^CNg
	pffs->nNumFonts++;
	return 1;
}

/******************************************************************************

	SetFontSizeList

	tHgTCYXgAbv

******************************************************************************/

static void SetFontSizeList (HWND hWnd)
{
	INT i;
	HWND hItem;
	TCHAR buf[32];
	INT nIndex;

	hItem = GetDlgItem (hWnd, IDC_LBFONTNAME);
	nIndex = SendMessage (hItem, LB_GETCURSEL, 0, 0);
 
	hItem = GetDlgItem (hWnd, IDC_LBFONTSIZE);
	SendMessage (hItem, LB_RESETCONTENT, 0, 0);

	if (nIndex != -1) {
		for (i = 0; i < ffs[nIndex].nNumFonts; i++) {
			tsprintf (buf, TEXT("%2d"), ffs[nIndex].aFontPoint[i]);
			SendMessage (hItem, LB_ADDSTRING, 0, (LPARAM)buf);
		}
	}
}

/******************************************************************************

	InitWindow

	EBhȄ

******************************************************************************/

static BOOL InitWindow(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	INT i, rc;
	HWND hItem;
	TCHAR buf[32];
	INT nIndex = -1;

#ifndef _WIN32_WCE
	//c[o[ɕ
	hItem = GetDlgItem (hWnd, IDC_CTBARMOJI);
	ShowWindow (hItem, SW_SHOW);
	SendMessage(hItem, BM_SETCHECK, g_Winpos.TbarType, 0);
#endif

	//R{anw̕\ON/OFF
	SendDlgItemMessage(hWnd, IDC_COMBVIEW, BM_SETCHECK, g_Winpos.fCombView, 0);

	//Tv̕\
	SendDlgItemMessage(hWnd, IDC_TYPSMPVEW, BM_SETCHECK, g_Winpos.typSmpView, 0);

	//AhX
	hItem = GetDlgItem (hWnd, IDC_EADRFORM);
	if (g_Winpos.AdrForm)
		SetWindowText (hItem, g_Winpos.AdrForm);

	// gpłtHg񋓂
	shDC = GetDC (hWnd);

	sFamilyCnt = 0;
	rc = EnumFontFamilies (shDC, NULL, FontFamilyCallback, 0);

	hItem = GetDlgItem (hWnd, IDC_LBFONTNAME);

	for (i = 0; i < sFamilyCnt; i++) {
		SendMessage (hItem, LB_ADDSTRING, 0, (LPARAM)ffs[i].szFontFamily);
		if (FontName) {
			if (TStrCmp(FontName, ffs[i].szFontFamily) == 0) nIndex = i;
		}

		ffs[i].nNumFonts = 0;
		rc = EnumFontFamilies (shDC, ffs[i].szFontFamily, 
			EnumSingleFontFamily, (LPARAM)(FONTFAMSTRUCT*)&ffs[i]);
	}

	if (FontName) {
		SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)FontName);
	}		

	ReleaseDC (hWnd, shDC);


	SetFontSizeList (hWnd);

	hItem = GetDlgItem (hWnd, IDC_LBFONTSIZE);
	tsprintf (buf, TEXT("%2d"), FontSize);
	rc = SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)buf);
	if (rc == CB_ERR) {
	//	SetWindowText (hItem, buf);
		rc = SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)"10");
		if (rc == CB_ERR) rc = SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)"14");
		if (rc == CB_ERR) rc = SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)" 8");
	}

	// V^XNo[ACR
	switch (g_Winpos.TbIconType) {
	default:
		hItem = GetDlgItem (hWnd, IDC_RTBICO1);
		break;
	case 1:
		hItem = GetDlgItem (hWnd, IDC_RTBICO2);
		break;
	case 2:
		hItem = GetDlgItem (hWnd, IDC_RTBICO3);
		break;
	}
	SendMessage (hItem, BM_SETCHECK, BST_CHECKED, 0);

	return TRUE;
}

/******************************************************************************

	GetSelectFont

	tHg

******************************************************************************/

static void GetSelectFont (HWND hWnd)
{
	HWND hItem;
	TCHAR buf[LF_FACESIZE];
	INT nIndex = -1;
	INT len;
	INT iSize;

	//tHg
	hItem = GetDlgItem (hWnd, IDC_LBFONTNAME);
	nIndex = SendMessage (hItem, LB_GETCURSEL, 0, 0);
	if (nIndex != -1) {
		SendMessage (hItem, LB_GETTEXT, nIndex, (LPARAM)buf);
	//	SendMessage (hItem, CB_GETLBTEXT, nIndex, (LPARAM)buf);
		if (FontName) LocalFree (FontName);
		FontName = 0;
		len = lstrlen(buf);
		FontName = (TCHAR *)LocalAlloc(LMEM_FIXED, sizeof(TCHAR) * (len + 1 + 32));
		if (FontName) TStrCpy (FontName, buf);
	}
	//tHgTCY
	hItem = GetDlgItem (hWnd, IDC_LBFONTSIZE);
	nIndex = SendMessage (hItem, LB_GETCURSEL, 0, 0);
	if (nIndex != -1) {
		SendMessage (hItem, LB_GETTEXT, nIndex, (LPARAM)buf);
//		SendMessage (hItem, CB_GETLBTEXT, nIndex, (LPARAM)buf);
	}
	else {
		GetWindowText (hItem, buf, LF_FACESIZE);
	}
#ifdef _WIN32_WCE
	iSize = _wtoi (buf);
#else
	iSize = atoi (buf); 
#endif
	if (iSize) FontSize = iSize;
	//tHgύX
	if (FontName && hEditFont) {
		extern int LvFontCharset;
		HFONT hFont = CreateEditFont(hWnd, FontName, FontSize, LvFontCharset);
		if (hFont) {
			if (g_hEditView) SendMessage(g_hEditView, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(TRUE,0));
			if (hEditWnd ) SendDlgItemMessage(hEditWnd, IDC_EDIT_BODY, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(TRUE,0));
			if (hViewWnd ) SendDlgItemMessage(hEditWnd, IDC_EDIT_BODY, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(TRUE,0));

			DeleteObject (hEditFont);
			hEditFont = hFont;
		}
	}
}

/******************************************************************************

	OptionNotifyProc

	vpeBV[g̃Cxg̒ʒm

******************************************************************************/

extern LRESULT OptionNotifyProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);


/******************************************************************************

	FontProc

	tHgIvV[W

******************************************************************************/

BOOL CALLBACK SetNpopqOptionProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_INITDIALOG:
		InitWindow(hDlg, wParam, lParam);
		break;

	case WM_NOTIFY:
		return OptionNotifyProc(hDlg, uMsg, wParam, lParam);

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_LBFONTNAME:
			if (HIWORD(wParam) == CBN_SELCHANGE) {
				HWND hItem;
				TCHAR buf[32];
				int rc;
				SetFontSizeList (hDlg);
				hItem = GetDlgItem (hDlg, IDC_LBFONTSIZE);
				tsprintf (buf, TEXT("%2d"), FontSize);
				//SetWindowText (hItem, buf);
				rc = SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)buf);
				if (rc == CB_ERR) {
					rc = SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)"10");
					if (rc == CB_ERR) rc = SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)"14");
					if (rc == CB_ERR) rc = SendMessage (hItem, LB_SELECTSTRING, -1, (LPARAM)" 8");
				}
			}
			break;

		case IDOK:
#ifndef _WIN32_WCE
			//c[o[ɕ
			g_Winpos.TbarType = SendDlgItemMessage(hDlg, IDC_CTBARMOJI, BM_GETCHECK, 0, 0);
#endif
			//R{anw̕\ON/OFF
			g_Winpos.fCombView = SendDlgItemMessage(hDlg, IDC_COMBVIEW, BM_GETCHECK, 0, 0);
			//Tv̕\
			g_Winpos.typSmpView = SendDlgItemMessage(hDlg, IDC_TYPSMPVEW, BM_GETCHECK, 0, 0);
			//AhX
			AllocGetText(GetDlgItem(hDlg, IDC_EADRFORM), &g_Winpos.AdrForm);
			//tHg
			GetSelectFont (hDlg);
			// V^XNo[ACR
			if (SendDlgItemMessage (hDlg, IDC_RTBICO2, BM_GETCHECK, 0,0))
				g_Winpos.TbIconType = 1;
			else if (SendDlgItemMessage (hDlg, IDC_RTBICO3, BM_GETCHECK, 0,0))
				g_Winpos.TbIconType = 2;
			else
				g_Winpos.TbIconType = 0;
		//	EndDialog(hDlg, TRUE);
			break;
		case IDCANCEL:
		//	EndDialog(hDlg, FALSE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/******************************************************************************

	FontSelect

	tHgI

******************************************************************************/
/*
int FontSelect (HINSTANCE hInstance, HWND hWnd)
{
	DialogBox (hInstance, MAKEINTRESOURCE(IDD_DIALOG_FONT), hWnd, FontProc);
	return 0;
}
*/
/* End of source */
