/**************************************************************************

	nPOP-Q

	TreeView.c

	(C) Copyright 1999-2002 By Qta Sakamoto. All right reserved.

**************************************************************************/

/**************************************************************************
	Include Files
**************************************************************************/

#include "General.h"


/**************************************************************************
	define
**************************************************************************/

#define SICONSIZE			16
#define ICONCOUNT			5
#define TREEMAXIT			200	// c[ڂ̍ő

#define ID_MENU_TREE		(WM_APP + 400)		//c[j[ main.cœl`

/**************************************************************************
	Global Variables
**************************************************************************/

int TreeSaveNo = -1;	//ۑ̃AJEgԍ
int TreeSendNo = -1;	//M̃AJEgԍ

//OQ
extern HINSTANCE hInst;
extern int SelBox;

extern int LvColSize[];

extern int LvAutoSort;
extern int LvSaveBoxSort;
extern int LvThreadView;

extern struct TPMAILBOX *MailBox;
extern int MailBoxCnt;

/**************************************************************************
	Local Function Prototypes
**************************************************************************/

HTREEITEM TreeView_InsertItemEx(HWND hTreeView, TCHAR *buf, int len, int Img, long lp, HTREEITEM hItem);

struct TREE_DATA	{
	HTREEITEM hTreeItem[TREEMAXIT];	// c[ڂ̃nh
	HTREEITEM hTreeRoot;	//M
	int       nTreeCunt;	//c[̎M(AJEg)̐

	int       nTrNoRead[TREEMAXIT];	//ǃ[

	HTREEITEM hTreeSave[TREEMAXIT];	// c[ڂ̃nh(ۑ)
	HTREEITEM hTreeSend[TREEMAXIT];	// c[ڂ̃nh(M)
};
struct TREE_DATA*	pTreeData = NULL;

/******************************************************************************

	CreateTreeView

	c[r[̍쐬Ə

******************************************************************************/

HWND CreateTreeView(HWND hWnd, int Top, int bottom)
{
    HBITMAP hBitmap;
	HIMAGELIST ImageList;
	RECT rcClient;
	HWND hTreeView;
	TVITEM tvi;

	pTreeData = (struct TREE_DATA*)LocalAlloc (LPTR, sizeof(struct TREE_DATA));
	if (pTreeData == NULL) {
		return NULL;
	}

	GetClientRect(hWnd, &rcClient);

#ifdef _WIN32_WCE
#define WS_EX_STYLE		0
#else
#define WS_EX_STYLE		WS_EX_NOPARENTNOTIFY | WS_EX_CLIENTEDGE
#endif

	hTreeView = CreateWindowEx (WS_EX_STYLE, WC_TREEVIEW, TEXT(""), 
#ifdef _WIN32_WCE
		WS_BORDER | 
//#else
//		TVS_LINESATROOT | 
#endif
		WS_VISIBLE | WS_CHILD | WS_TABSTOP | TVS_HASLINES | TVS_HASBUTTONS | TVS_SHOWSELALWAYS ,
		0, Top, rcClient.right, rcClient.bottom - Top - bottom,
		hWnd, (HMENU)IDC_TREEVIEW, hInst, NULL);
	if(hTreeView == NULL){
		return NULL;
	}

	//C[WXg̐ݒ
    ImageList = ImageList_Create (SICONSIZE, SICONSIZE, 
		ILC_COLOR/* | ILC_MASK*/, ICONCOUNT, ICONCOUNT);

    //rbg}bvC[W[h
    hBitmap = LoadBitmap (hInst, MAKEINTRESOURCE (IDB_TREEIMG));
    ImageList_Add (ImageList, hBitmap, NULL);
    DeleteObject (hBitmap);

	// C[W Xgo^
	TreeView_SetImageList (hTreeView, ImageList, TVSIL_NORMAL);

	// c[ڂ̃nh
	memset (pTreeData->hTreeItem, 0, sizeof(pTreeData->hTreeItem));

	memset (pTreeData->hTreeSave, 0, sizeof(pTreeData->hTreeSave));	//ۑ
	memset (pTreeData->hTreeSend, 0, sizeof(pTreeData->hTreeSend));	//M

	//ǂ̐
	memset (pTreeData->nTrNoRead, 0, sizeof(pTreeData->nTrNoRead));

	// M
	pTreeData->hTreeRoot = TreeView_InsertItemEx (hTreeView, 
		STR_TREEBOX_NAME, lstrlen(STR_TREEBOX_NAME), 2, -1, NULL);

	tvi.hItem      = pTreeData->hTreeRoot;
	tvi.mask       = TVIF_CHILDREN;
	tvi.cChildren  = 1;
	TreeView_SetItem (hTreeView, &tvi);

	pTreeData->nTreeCunt = 0;	//AJEg

	return hTreeView;
}

/******************************************************************************

	TreeView_NoReadCunt

	ǂ̐

******************************************************************************/
void TreeView_NoReadCunt (int Sel, int Cnt)
{
	if (Sel < 0 || Sel >= TREEMAXIT) {
		return;
	}
	pTreeData->nTrNoRead[Sel] = Cnt;
}

/******************************************************************************


	c[̕ۑɃAJEg

******************************************************************************/
/*
void TreeView_AddSaveBox (HWND hTreeView)
{
	TVITEM tvi;
	int Sel;
	int len;
	TCHAR* Name;
	int i = 0;

	//ۑ
	if (!hTreeItem[MAILBOX_SAVE])
		return;

	//c[ɏl
	for (Sel = MAILBOX_USER; Sel < MailBoxCnt; Sel++){
		Name = (((MailBox + Sel)->Name == NULL || *(MailBox + Sel)->Name == TEXT('\0'))
			? STR_MAILBOX_NONAME : (MailBox + Sel)->Name);
		len = lstrlen(Name);

		hTreeSave[i] = TreeView_InsertItemEx (
			hTreeView, Name, len, 0, -1, hTreeItem[MAILBOX_SAVE]);
		i++;
	}

	Name = TEXT("̑");
	len = lstrlen(Name);
	hTreeSave[i] = TreeView_InsertItemEx (
		hTreeView, Name, len, 0, -1, hTreeItem[MAILBOX_SAVE]);

	//c[̊Kw{^
	tvi.hItem      = hTreeItem[MAILBOX_SAVE];
	tvi.mask       = TVIF_CHILDREN;
	tvi.cChildren  = 1;
	TreeView_SetItem (hTreeView, &tvi);
}
*/
void TreeView_ChiSaveBox (HWND hTreeView, int Sel)
{
	int i;
	TVITEM tvi;
	int len;
	TCHAR* Name;

	//AJEg̏̂
	if (Sel < MAILBOX_USER)
		return;
	//ۑ
	if (!pTreeData->hTreeItem[MAILBOX_SAVE])
		return;

	if (Sel >= MailBoxCnt) {
		Name = STR_SETSEND_BTN_ETC;
	}
	else {
		//AJEg擾
		Name = (((MailBox + Sel)->Name == NULL || *(MailBox + Sel)->Name == TEXT('\0'))
			? STR_MAILBOX_NONAME : (MailBox + Sel)->Name);
	}
	len = lstrlen(Name);

	//AJEgubNN_ɂ
	i = Sel - MAILBOX_USER;

	if (pTreeData->hTreeSave[i] == 0) {
		//AJEgǉ
		pTreeData->hTreeSave[i] = TreeView_InsertItemEx (
			hTreeView, Name, len, 0, i-100, pTreeData->hTreeItem[MAILBOX_SAVE]);

		//c[̊Kw{^
		tvi.hItem      = pTreeData->hTreeItem[MAILBOX_SAVE];
		tvi.mask       = TVIF_CHILDREN;
		tvi.cChildren  = 1;
		TreeView_SetItem (hTreeView, &tvi);
	}
	else {
		//AJEgύX
		tvi.hItem      = pTreeData->hTreeSave[i];
		tvi.mask       = TVIF_TEXT;
	    tvi.pszText    = Name;
		tvi.cchTextMax = len;
		TreeView_SetItem (hTreeView, &tvi);
	}
}

/******************************************************************************


	c[̑MɃAJEg

******************************************************************************/
/*
void TreeView_AddSendBox (HWND hTreeView)
{
	TVITEM tvi;
	int Sel;
	int len;
	TCHAR* Name;
	int i = 0;

	//ۑ
	if (!hTreeItem[MAILBOX_SEND])
		return;

	//c[ɏl
	for (Sel = MAILBOX_USER; Sel < MailBoxCnt; Sel++){
		Name = (((MailBox + Sel)->Name == NULL || *(MailBox + Sel)->Name == TEXT('\0'))
			? STR_MAILBOX_NONAME : (MailBox + Sel)->Name);
		len = lstrlen(Name);

		hTreeSend[i] = TreeView_InsertItemEx (
			hTreeView, Name, len, 0, -1, hTreeItem[MAILBOX_SEND]);
		i++;
	}

	Name = TEXT("̑");
	len = lstrlen(Name);
	hTreeSend[i] = TreeView_InsertItemEx (
		hTreeView, Name, len, 0, -1, hTreeItem[MAILBOX_SEND]);

	//c[̊Kw{^
	tvi.hItem      = hTreeItem[MAILBOX_SEND];
	tvi.mask       = TVIF_CHILDREN;
	tvi.cChildren  = 1;
	TreeView_SetItem (hTreeView, &tvi);
}
*/
void TreeView_ChiSendBox (HWND hTreeView, int Sel)
{
	int i;
	TVITEM tvi;
	int len;
	TCHAR* Name;

	//AJEg̏̂
	if (Sel < MAILBOX_USER)
		return;
	//ۑ
	if (!pTreeData->hTreeItem[MAILBOX_SEND])
		return;

	if (Sel >= MailBoxCnt) {
		Name = STR_SETSEND_BTN_ETC;
	}
	else {
		//AJEg擾
		Name = (((MailBox + Sel)->Name == NULL || *(MailBox + Sel)->Name == TEXT('\0'))
			? STR_MAILBOX_NONAME : (MailBox + Sel)->Name);
	}
	len = lstrlen(Name);

	//AJEgubNN_ɂ
	i = Sel - MAILBOX_USER;

	if (pTreeData->hTreeSend[i] == 0) {
		//AJEgǉ
		pTreeData->hTreeSend[i] = TreeView_InsertItemEx (
			hTreeView, Name, len, 0, i-100-100, pTreeData->hTreeItem[MAILBOX_SEND]);

		//c[̊Kw{^
		tvi.hItem      = pTreeData->hTreeItem[MAILBOX_SEND];
		tvi.mask       = TVIF_CHILDREN;
		tvi.cChildren  = 1;
		TreeView_SetItem (hTreeView, &tvi);
	}
	else {
		//AJEgύX
		tvi.hItem      = pTreeData->hTreeSend[i];
		tvi.mask       = TVIF_TEXT;
	    tvi.pszText    = Name;
		tvi.cchTextMax = len;
		TreeView_SetItem (hTreeView, &tvi);
	}
}

/******************************************************************************

	TreeView_SetIconType

	c[r[̃ACRύX

******************************************************************************/

void TreeView_SetIconType(HWND hTreeView, int Sel)
{
	struct TPMAILBOX *tpMailBox;
	struct TPMAILITEM *tpMailItem;
	int NewCnt = 0;
	int NoReadCnt = 0;
	int i;

	if (Sel < 0 || Sel >= TREEMAXIT) {
		return;
	}

	if (Sel >=  MailBoxCnt) {
		return;
	}

	tpMailBox = (MailBox + Sel);
	if(tpMailBox == NULL){
		return;
	}

	for(i = 0; i < tpMailBox->MailItemCnt; i++){
		tpMailItem = *(tpMailBox->tpMailItem + i);
		if(tpMailItem == NULL){
			continue;
		}
		if(tpMailItem->New == TRUE){
			NewCnt++;
		}
		if(tpMailItem->MailStatus == ICON_MAIL){
			NoReadCnt++;
		}
	}
	// ǐ (nPOP-Q)
	TreeView_NoReadCunt (Sel, NoReadCnt);
	TreeView_SelMailBox (hTreeView, Sel, FALSE);
}


/******************************************************************************

	TreeView_SelMailBox

	c[r[̃ACeZbg

******************************************************************************/
void TreeView_SelMailBox(HWND hTreeView, int Sel, int fFocus)
{
	int len;
	TCHAR* Name;

	// c[ڂ͈̔
	if (Sel < 0 || Sel >= TREEMAXIT) {
		return;
	}

	if (Sel >=  MailBoxCnt) {
		return;
	}

	Name = (((MailBox + Sel)->Name == NULL || *(MailBox + Sel)->Name == TEXT('\0'))
		? STR_MAILBOX_NONAME : (MailBox + Sel)->Name);
	len = lstrlen(Name);

	if (pTreeData->hTreeItem[Sel] == 0) {
		if (Sel >= MAILBOX_USER) {
			//ǁHǁH
			int iImage = 0;
			if (pTreeData->nTrNoRead[Sel]) iImage = 1;
			if ((MailBox + Sel)->NoRead) iImage = 3;
			//AJEg
			pTreeData->hTreeItem[Sel] = TreeView_InsertItemEx (
				hTreeView, Name, len, iImage, Sel, pTreeData->hTreeRoot);
			pTreeData->nTreeCunt++;
			//ۑɃAJEgǉ
			TreeView_ChiSaveBox (hTreeView, Sel);
			//MɃAJEgǉ
			TreeView_ChiSendBox (hTreeView, Sel);
		}
		else {
			//...
			pTreeData->hTreeItem[Sel] = TreeView_InsertItemEx (
				hTreeView, Name, len, 2, Sel, NULL);
		}
	}
	else {
		//eLXgƃACRXV
		TVITEM tvi;
		memset (&tvi, 0, sizeof (tvi));
		if (Sel >= MAILBOX_USER) {
			//ǁHǁH
			int iImage = 0;
			if (pTreeData->nTrNoRead[Sel]) iImage = 1;
			if ((MailBox + Sel)->NoRead)
				iImage = 3;
			tvi.iImage         = iImage;
			tvi.iSelectedImage = iImage;
		}
		else {
			tvi.iImage         = 2;
			tvi.iSelectedImage = 2;
		}
		tvi.hItem      = pTreeData->hTreeItem[Sel];
		tvi.mask       = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
        tvi.pszText    = Name;
		tvi.cchTextMax = len;
		TreeView_SetItem (hTreeView, &tvi);
		//ۑɃAJEgύX
		TreeView_ChiSaveBox (hTreeView, Sel);
		//MɃAJEgύX
		TreeView_ChiSendBox (hTreeView, Sel);
	}

	// Iw
	if (fFocus && pTreeData->hTreeItem[Sel] != 0)
		TreeView_Select (hTreeView, pTreeData->hTreeItem[Sel], TVGN_CARET);
}

/******************************************************************************

	TreeView_ResetMailBox

	c[r[̃ACeăZbg

******************************************************************************/
void TreeView_ResetMailBox(HWND hTreeView, int fDelOnly)
{
	int i;
	int Sel;
	HTREEITEM hTeeSele;
	TCHAR* Name;

	TreeSaveNo = -1;	//ۑ̃AJEgI
	TreeSendNo = -1;	//M̃AJEgI

	//݂̑I
	hTeeSele = TreeView_GetSelection(hTreeView);
	Sel = -1;

	// Iw
	TreeView_Select (hTreeView, pTreeData->hTreeRoot, TVGN_CARET);

	//ݓo^̃c[\̃AJEg
	for(i = MAILBOX_USER;i < MAILBOX_USER+pTreeData->nTreeCunt;i++){
		//ۑ
		if (pTreeData->hTreeSave[i-MAILBOX_USER] != 0) {
			TreeView_DeleteItem (hTreeView, pTreeData->hTreeSave[i-MAILBOX_USER]);
			pTreeData->hTreeSave[i-MAILBOX_USER] = 0;
		}
		//M
		if (pTreeData->hTreeSend[i-MAILBOX_USER] != 0) {
			TreeView_DeleteItem (hTreeView, pTreeData->hTreeSend[i-MAILBOX_USER]);
			pTreeData->hTreeSend[i-MAILBOX_USER] = 0;
		}
		//M
		if (pTreeData->hTreeItem[i] != 0) {
			if (pTreeData->hTreeItem[i] == hTeeSele) Sel = i;
			TreeView_DeleteItem (hTreeView, pTreeData->hTreeItem[i]);
			pTreeData->hTreeItem[i] = 0;
		}
	}
	if (fDelOnly) {
		pTreeData->nTreeCunt = 0;
		return;
	}

	//ۂ̌c[ɃAJEg\
	pTreeData->nTreeCunt = 0;
	for(i = MAILBOX_USER;i < MailBoxCnt;i++){
		Name = (((MailBox + i)->Name == NULL || *(MailBox + i)->Name == TEXT('\0'))
			? STR_MAILBOX_NONAME : (MailBox + i)->Name);

		pTreeData->hTreeItem[i] = TreeView_InsertItemEx (
			hTreeView, Name, lstrlen(Name), 0, i, pTreeData->hTreeRoot);
		pTreeData->nTreeCunt++;

		//ۑɃAJEgǉ
		TreeView_ChiSaveBox (hTreeView, i);
		//MɃAJEgǉ
		TreeView_ChiSendBox (hTreeView, i);
	}

	//ۑɃAJEgǉ (̑)
	TreeView_ChiSaveBox (hTreeView, i);

	// Iw
	if (Sel != -1 && Sel < MailBoxCnt)
		TreeView_Select (hTreeView, pTreeData->hTreeItem[Sel], TVGN_CARET);
	else if (hTeeSele != NULL)
		TreeView_Select (hTreeView, hTeeSele, TVGN_CARET);
}

/******************************************************************************

	TreeView_SetNoReadCntTitle

	ǃ[{bNX̃ACRύX

******************************************************************************/
void TreeView_SetNoRead(HWND hTreeView, int Sel)
{
	TVITEM tvi;
    memset (&tvi, 0, sizeof (tvi));
	tvi.hItem          = pTreeData->hTreeItem[Sel];
	tvi.mask           = TVIF_IMAGE | TVIF_SELECTEDIMAGE;
    tvi.iImage         = 1;
    tvi.iSelectedImage = 1;
	TreeView_SetItem (hTreeView, &tvi);
}

/******************************************************************************

	TreeView_InsertItemEx

	c[r[ɃACeǉ

******************************************************************************/

HTREEITEM TreeView_InsertItemEx(HWND hTreeView, TCHAR *buf, int len, int Img, long lp, HTREEITEM hItem)
{
    TV_INSERTSTRUCT tvis;

    memset (&tvis, 0, sizeof (tvis));
    tvis.hParent             = hItem;
    tvis.hInsertAfter        = TVI_LAST;
    tvis.item.mask           = TVIF_TEXT | TVIF_PARAM | 
		TVIF_CHILDREN | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
    tvis.item.pszText        = buf;
    tvis.item.cchTextMax     = len;
    tvis.item.iImage         = Img;
    tvis.item.iSelectedImage = Img;
    tvis.item.lParam         = lp;
	tvis.item.cChildren      = 0;

	// c[r[ɃACeǉ
    return TreeView_InsertItem (hTreeView, &tvis);
}

/******************************************************************************

	TreeView_GetIndex

	c[r[̍ڂMailBox̃CfbNX擾

******************************************************************************/
int TreeView_GetIndex(HTREEITEM hTreeSele)
{
	int i;
	for(i = MAILBOX_USER;i <  MailBoxCnt;i++){
		if (pTreeData->hTreeItem[i] == hTreeSele) {
			return i;
		}
	}
	return 0;
}

/******************************************************************************

	TreeView_NotifyProc

	c[r[Cxg

******************************************************************************/

LRESULT TreeView_NotifyProc(HWND hWnd, LPARAM lParam)
{
	NM_TREEVIEW* ptv = (NM_TREEVIEW *)lParam;
	NMHDR *CForm = (NMHDR *)lParam;
	int Sel = -1;
	int i;

	switch(ptv->hdr.code)
	{
	case TVN_SELCHANGED:		//ACȇIԂ̕ύX
		if (ptv->itemNew.lParam != -1)
			Sel = ptv->itemNew.lParam;
		else if (SelBox != -1)
			Sel = SelBox;
		if (Sel >= 0 && Sel < MailBoxCnt) {
			//R{̑I
			SendDlgItemMessage(hWnd, IDC_COMBO, CB_SETCURSEL, Sel, 0);
			//Xg̑I
			SetFocus(GetDlgItem(hWnd, IDC_LISTVIEW));
			SelectMailBox(hWnd, Sel);
			break;
		}
		else {
			Sel += 100;
		}
		if (Sel >= 0) {
			i = Sel;
			if (i >= 0 && i < 10) {
				TreeSaveNo = i;
				Sel = MAILBOX_SAVE;
				//R{̑I
				SendDlgItemMessage(hWnd, IDC_COMBO, CB_SETCURSEL, Sel, 0);
				//Xg̑I
				SetFocus(GetDlgItem(hWnd, IDC_LISTVIEW));
				SelectMailBox(hWnd, Sel);
			}
			break;
		}
		else {
			Sel += 100;
		}
		if (Sel >= 0) {
			i = Sel;
			if (i >= 0 && i < 10) {
				TreeSendNo = i;
				Sel = MAILBOX_SEND;
				//R{̑I
				SendDlgItemMessage(hWnd, IDC_COMBO, CB_SETCURSEL, Sel, 0);
				//Xg̑I
				SetFocus(GetDlgItem(hWnd, IDC_LISTVIEW));
				SelectMailBox(hWnd, Sel);
			}
			break;
		}
		return FALSE;
	}

	switch(CForm->code)
	{
	case NM_CLICK:				//NbN
		return FALSE;
	case NM_DBLCLK:				//_uNbN
		if (SelBox == MAILBOX_SAVE) {
			//ۑ̃AJEgI
			TreeSaveNo = -1;
		}
		if (SelBox == MAILBOX_SEND) {
			//M̃AJEgI
			TreeSendNo = -1;
		}
		Sel = SelBox;
		//ۑđI
		//Sel = MAILBOX_SAVE;
		//R{̑I
		SendDlgItemMessage(hWnd, IDC_COMBO, CB_SETCURSEL, Sel, 0);
		//Xg̑I
		SetFocus(GetDlgItem(hWnd, IDC_LISTVIEW));
		SelectMailBox(hWnd, Sel);
		return FALSE;

	case NM_RCLICK:				//ENbN
		SendMessage(hWnd, WM_COMMAND, ID_MENU_TREE, 0);
		return FALSE;
	}
	return FALSE;
}

/******************************************************************************

	GetMailadr

	񂩂S~ră[AhX݂̂ɂ

******************************************************************************/

TCHAR* GetMailadr (TCHAR* madr)
{
	static TCHAR str[MAX_PATH];
	TCHAR *p, *s;
	int MailToFlag = 0;

//#ifdef UNICODE
//	wcsncpy (str, madr, MAX_PATH-1);
//#else
//	strncpy (str, madr, MAX_PATH-1);
//#endif
#ifdef UNICODE
	p = wcschr (madr, TEXT('@'));
#else
	p = strchr (madr, TEXT('@'));
#endif
	if (p == NULL)
		return TEXT("");

	//S~̏
	for (s = p; madr != s && !(*s == TEXT('(') || *s == TEXT(')') || *s == TEXT('\"') ||
		*s == TEXT('<') || *s == TEXT('>') || *s == TEXT('\t') || *s == TEXT(' ') || 
		*s == TEXT(',') || *s == TEXT(';')); s--);

#ifdef UNICODE
	wcsncpy (str, s, MAX_PATH-1);
#else
	strncpy (str, s, MAX_PATH-1);
#endif

	//S~̏
	for(s = str;*s == TEXT('(') || *s == TEXT(')') || *s == TEXT('\"') ||
		*s == TEXT('<') || *s == TEXT('>') || *s == TEXT('\t') || *s == TEXT(' ') ||
		*s == TEXT(',') || *s == TEXT(';') ;s++);

	for(p = s;*p != TEXT('\0');p++){
		if(*p == TEXT('(') || *p == TEXT(')') || *p == TEXT('\"') ||
			*p == TEXT('<') || *p == TEXT('>') ||
			*p == TEXT('\r') || *p == TEXT('\n') || *p == TEXT('\t') ||
			*p == TEXT(' ') || *s == TEXT(',') || *s == TEXT(';')){ // || IsLeadChar(*p) == TRUE){
			*p = TEXT('\0');
			break;
		}
		if(*p == TEXT('@')){
			if(MailToFlag != 0){
				MailToFlag = -1;
			}else{
				MailToFlag = 1;
			}
		}
	}
	if(*s == TEXT('\0')){
		return TEXT("");
	}
	return s;
}

/* End of source */
